'From Squeak3.7beta of ''1 April 2004'' [latest update: #5969] on 9 July 2004 at 2:15:27 pm'!
"Change Set:		Compiler-ajh
Date:			14 Map 2004
Author:			Anthony Hannan <ajh18@cornell.edu>

This adds the closure compiler.  It uses SmaCC and the RB AST.  Closures-ajh must be filed in before this.  To use the closure compiler set Preferences compileBlocksAsClosures to true.  Read the Compiler class comment for more."!


!Compiler commentStamp: 'ajh 3/26/2003 00:37' prior: 0!
The compiler accepts Smalltalk source code and compiles it with respect to a given class. The user of the compiler may supply a context so that temporary variables are accessible during compilation. If there is an error, a requestor (usually a kind of StringHolderController) is sent the message notify:at:in: so that the error message can be displayed. If there is no error, then the result of compilation is a MethodNode, which is the root of a parse tree whose nodes are kinds of ParseNodes. The parse tree can be sent messages to (1) generate code for a CompiledMethod (this is done for compiling methods or evaluating expressions); (2) pretty-print the code (for formatting); or (3) produce a map from object code back to source code (used by debugger program-counter selection).

----

Closure Compiler
by Anthony Hannan 3/13/2003

The Compiler class (like before) serves as the interface to the compiler.  If Preferences compileBlocksAsClosures is true it will run the new closure compiler.  The closure compiler classes reside in their own system category called 'Compiler', which is broken down into four minor categories: 'Compiler-Syntax', 'Compiler-Semantics', 'Compiler-IR', and 'Compiler-Bytecodes'.  The closure compiler also uses classes in 'SmaCC-Runtime' and the Refactory abstract syntax tree in 'Refactory-Parser'.

Like most compilers, the closure compiler translates source text into bytecodes in a sequence of phases or transformations.

Phase 1 - Scan and parse text into abstract syntax tree (AST)

SqueakScanner and SqueakParser in 'Compiler-Syntax' transform a method or do-it text into a Refactory abstract syntax tree.  SqueakScanner and SqueakParser classes were automatically generated using the SmaCC parser generator from a token and grammar specification derived from the StScanner and StParser specifications that comes with SmaCC.

Phase 2 - Verify and annotate AST (semantic analysis)

SemanticChecker in 'Compiler-Semantics' binds RBVariableNodes in the AST to temp, instance, or pool (class, pool, or global) SemVars, raising a notifier if no match is found.  The lookup is performed on a chain of SemScopes, one for the class, method and each nested closure.  Var usage (read/write/capture-in-closure) is tracked using a FiniteAutomaton.  The final usage state is used to determine unused temps and escaping temps (temps whose storage need to reside independent of the context since a block may assign to it after the context is gone).

Phase 3 - Translate AST to intermediate representation (IR)

SemanticTranslator in 'Compiler-Semantics' visits each node in the AST and invokes the appropriate instruction message on IRBuilder in 'Compiler-IR' resulting in an IRMethod.  An IRMethod consists of IRInstructions grouped by IRSequence (basic block).  Each IRInstruction represents a simple stack instruction like pushTemp: or send:.

Phase 4 - Optimize IR

Two simple optimization are applied to the IRMethod: absorbJumpsToSingleInstrs and absorbConstantConditionalJumps. The first eliminates jumps to returns and returns directly.  The second converts chained constant jumps created by and:/or: to single jumps directly to the target code.

Phase 5 - Translate IR to bytecodes (CompiledMethod)

IRTranslator in 'Compiler-IR' visits each IR instruction and invokes the appropriate bytecode message on BytecodeGenerator in 'Compiler-Bytecodes'.  Certain combinations of IR instructions (like storeTemp: and popTop) are mapped to a single bytecode instructions.
!

RBValueNode subclass: #RBArrayNode
	instanceVariableNames: 'leftBrace rightBrace statements '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-SqueakRB-ParserExtensions'!
RBValueNode subclass: #RBBlockNode
	instanceVariableNames: 'left right colons body arguments bar ir scope '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Parser'!
RBProgramNode subclass: #RBDoItNode
	instanceVariableNames: 'body source tags scope ir'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-SqueakRB-ParserExtensions'!
RBValueNode subclass: #RBLiteralNode
	instanceVariableNames: 'token value '
	classVariableNames: 'Null '
	poolDictionaries: ''
	category: 'Refactory-Parser'!
RBProgramNode subclass: #RBMethodNode
	instanceVariableNames: 'selector selectorParts body source arguments tags primitiveNode ir scope '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Parser'!
RBProgramNodeVisitor subclass: #RBFormatter
	instanceVariableNames: 'codeStream lineStart firstLineLength tabs positionDelta '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Parser'!
RBProgramNode subclass: #RBPseudoNode
	instanceVariableNames: 'mapInstr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-SqueakRB-ParserExtensions'!

!RBPseudoNode commentStamp: 'ajh 6/27/2004 15:13' prior: 0!
Used by IRDecompiler to represent intermediate nodes that eventually get reduced to real parse nodes.!

RBPseudoNode subclass: #RBPseudoDupNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-SqueakRB-ParserExtensions'!
RBPseudoNode subclass: #RBPseudoGotoNode
	instanceVariableNames: 'destination forValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-SqueakRB-ParserExtensions'!
RBPseudoNode subclass: #RBPseudoIfNode
	instanceVariableNames: 'boolean destination otherwise'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-SqueakRB-ParserExtensions'!
RBPseudoNode subclass: #RBPseudoLabelNode
	instanceVariableNames: 'destination'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-SqueakRB-ParserExtensions'!
RBPseudoNode subclass: #RBPseudoPopNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-SqueakRB-ParserExtensions'!
RBPseudoNode subclass: #RBPseudoSendNode
	instanceVariableNames: 'selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-SqueakRB-ParserExtensions'!
RBProgramNode subclass: #RBReturnNode
	instanceVariableNames: 'return value homeBinding '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Parser'!
RBValueNode subclass: #RBVariableNode
	instanceVariableNames: 'token binding '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Parser'!

!Object methodsFor: 'evaluating' stamp: 'ajh 6/29/2004 14:40'!
doItScope

	^ self class parseScope instanceScope! !


!Behavior methodsFor: 'accessing' stamp: 'ajh 3/13/2003 21:13'!
decompilerClass
	"Answer a decompiler class appropriate for compiled methods of this class."

	^ Preferences compileBlocksAsClosures
		ifTrue: [Decompiler2]
		ifFalse: [Decompiler]! !

!Behavior methodsFor: 'compiling' stamp: 'ajh 6/23/2004 19:45'!
parseScope

	^ ClassScope new class: self! !

!Behavior methodsFor: 'private' stamp: 'ajh 5/14/2004 20:36'!
basicCompile: code notifying: requestor trailer: bytes ifFail: failBlock
	"Compile code without logging the source in the changes file"

	| methodNode |
	methodNode _ self compilerClass new
				compile: code
				in: self
				notifying: requestor
				ifFail: failBlock.
	Preferences compileBlocksAsClosures ifFalse: [
		methodNode encoder requestor: requestor].
	^ CompiledMethodWithNode generateMethodFromNode: methodNode trailer: bytes.! !


!ClassDescription methodsFor: 'compiling' stamp: 'ajh 3/11/2003 19:13'!
compile: code notifying: requestor trailer: bytes 
		ifFail: failBlock
		elseSetSelectorAndNode: selAndNodeBlock
	"Intercept this message in order to remember system changes.
	 5/15/96 sw: modified so that if the class does not wish its methods logged in the changes file, then they also won't be accumulated in the current change set.
	7/12/96 sw: use wantsChangeSetLogging to determine whether to put in change set"

	| methodNode selector newMethod priorMethodOrNil |
	methodNode _ self compilerClass new
				compile: code
				in: self
				notifying: requestor
				ifFail: failBlock.
	selector _ methodNode selector.
	selAndNodeBlock value: selector value: methodNode.
	requestor ifNotNil:
		["Note this change for recent submissions list"
		Utilities noteMethodSubmission: selector forClass: self].
	Preferences compileBlocksAsClosures ifFalse: [
		methodNode encoder requestor: requestor].  "Why was this not preserved?"
	newMethod _ methodNode generate: bytes.
	priorMethodOrNil _ (self methodDict includesKey: selector)
		ifTrue: [self compiledMethodAt: selector]
		ifFalse: [nil].
	Smalltalk changes noteNewMethod: newMethod forClass: self
		selector: selector priorMethod: priorMethodOrNil.
	self addSelector: selector withMethod: newMethod.
	^ newMethod! !

!ClassDescription methodsFor: 'fileIn/Out' stamp: 'ajh 3/15/2003 16:02'!
printMethodChunk: selector withPreamble: doPreamble on: outStream
		moveSource: moveSource toFile: fileIndex
	"Copy the source code for the method associated with selector onto the fileStream.  If moveSource true, then also set the source code pointer of the method."
	| preamble method oldPos newPos sourceFile endPos |
	doPreamble 
		ifTrue: [preamble _ self name , ' methodsFor: ' ,
					(self organization categoryOfElement: selector) asString printString]
		ifFalse: [preamble _ ''].
	method _ self methodDict at: selector.
	((method fileIndex = 0
		or: [(SourceFiles at: method fileIndex) == nil])
		or: [(oldPos _ method filePosition) = 0])
		ifTrue:
		["The source code is not accessible.  We must decompile..."
		preamble size > 0 ifTrue: [outStream cr; nextPut: $!!; nextChunkPut: preamble; cr].
		outStream nextChunkPut: (method decompilerClass new decompile: selector
											in: self method: method) decompileString]
		ifFalse:
		[sourceFile _ SourceFiles at: method fileIndex.
		sourceFile position: oldPos.
		preamble size > 0 ifTrue:    "Copy the preamble"
			[outStream copyPreamble: preamble from: sourceFile].
		"Copy the method chunk"
		newPos _ outStream position.
		outStream copyMethodChunkFrom: sourceFile.
		sourceFile skipSeparators.      "The following chunk may have ]style["
		sourceFile peek == $] ifTrue: [
			outStream cr; copyMethodChunkFrom: sourceFile].
		moveSource ifTrue:    "Set the new method source pointer"
			[endPos _ outStream position.
			method checkOKToAdd: endPos - newPos at: newPos.
			method setSourcePosition: newPos inFile: fileIndex]].
	preamble size > 0 ifTrue: [outStream nextChunkPut: ' '].
	^ outStream cr! !


!CodeHolder methodsFor: 'message list' stamp: 'ajh 3/15/2003 16:03'!
decompiledSourceIntoContents
	"Obtain a source string by decompiling the method's code, and place that source string into my contents.  Get temps from source file"

	| tempNames class selector method |
	class _ self selectedClassOrMetaClass.
	selector _ self selectedMessageName.
	method _ class compiledMethodAt: selector ifAbsent: [^ ''].	"method deleted while in another project"
	currentCompiledMethod _ method.

	tempNames _ (class compilerClass new
					parse: method getSourceFromFile asString in: class notifying: nil)
					tempNames.
	contents _ ((method decompilerClass new withTempNames: tempNames)
			decompile: selector in: class method: method) decompileString.
	contents _ contents asText makeSelectorBoldIn: class.
	^ contents copy! !

!CodeHolder methodsFor: 'message list' stamp: 'ajh 3/15/2003 16:03'!
selectedMessage
	"Answer a copy of the source code for the selected message.  This generic version is probably actually never reached, since every subclass probably reimplements and does not send to super.  In time, ideally, most, or all, reimplementors would vanish and all would defer instead to a universal version right here.  Everything in good time."

	| class selector method tempNames |
	contents == nil ifFalse: [^ contents copy].
	self showingDecompile ifTrue:
		[^ self decompiledSourceIntoContents].

	class _ self selectedClassOrMetaClass.
	(class isNil or: [(selector _ self selectedMessageName) isNil]) ifTrue: [^ ''].
	method _ class compiledMethodAt: selector ifAbsent: [^ ''].	"method deleted while in another project"
	currentCompiledMethod _ method.

	(Sensor controlKeyPressed
		or: [method fileIndex > 0 and: [(SourceFiles at: method fileIndex) == nil]])
		ifTrue:
		["Emergency or no source file -- decompile without temp names"
		contents _ (method decompilerClass new decompile: selector in: class method: method)
			decompileString.
		contents _ contents asText makeSelectorBoldIn: class.
		^ contents copy].

	Sensor leftShiftDown ifTrue:
		["Special request to decompile -- get temps from source file"
		tempNames _ (class compilerClass new
						parse: method getSourceFromFile asString in: class notifying: nil)
						tempNames.
		contents _ ((method decompilerClass new withTempNames: tempNames)
				decompile: selector in: class method: method) decompileString.
		contents _ contents asText makeSelectorBoldIn: class.
		^ contents copy].

	self showComment
		ifFalse:
			[contents _ self sourceStringPrettifiedAndDiffed]
		ifTrue:
			[contents _ self commentContents].
	^ contents _ contents copy asText makeSelectorBoldIn: class! !


!Browser methodsFor: 'message list' stamp: 'ajh 3/15/2003 16:02'!
selectedMessage
	"Answer a copy of the source code for the selected message."

	| class selector method |
	contents == nil ifFalse: [^ contents copy].
	self showingDecompile ifTrue:
		[^ self decompiledSourceIntoContents].

	class _ self selectedClassOrMetaClass.
	selector _ self selectedMessageName.
	method _ class compiledMethodAt: selector ifAbsent: [^ ''].	"method deleted while in another project"
	currentCompiledMethod _ method.

	(Sensor controlKeyPressed
		or: [method fileIndex > 0 and: [(SourceFiles at: method fileIndex) == nil]])
		ifTrue:
		["Emergency or no source file -- decompile without temp names"
		contents _ (method decompilerClass new decompile: selector in: class method: method)
			decompileString.
		contents _ contents asText makeSelectorBoldIn: class.
		^ contents copy].

	Sensor leftShiftDown ifTrue:
		["Special request to decompile, old and dubious interface"
		^ self decompiledSourceIntoContents].

	self showingDocumentation
		ifFalse:
			[contents _ self sourceStringPrettifiedAndDiffed]
		ifTrue:
			[contents _ self commentContents].
	^ contents _ contents copy asText makeSelectorBoldIn: class! !


!CompiledMethod methodsFor: 'printing' stamp: 'ajh 3/15/2003 16:01'!
decompileString
	| clAndSel cl sel |
	clAndSel _ self who.
	clAndSel = #(unknown unknown)
		ifTrue:
			[cl _ Object.
			sel _ #xxxUnknown.
			self numArgs >= 1
				ifTrue:
					[sel _ sel , ':'.
					2 to: self numArgs do: [:i | sel _ sel , 'with:'].
					sel _ sel asSymbol]]
		ifFalse:
			[cl _ clAndSel first.
			sel _ clAndSel last].
	^ (self decompilerClass new
			decompile: sel in: cl method: self) decompileString! !

!CompiledMethod methodsFor: 'literals' stamp: 'ajh 5/20/2004 00:23'!
containsBlockClosures

	^ self embeddedBlockMethods size > 0! !

!CompiledMethod methodsFor: 'scanning' stamp: 'ajh 7/7/2004 18:20'!
readsField: varIndex 
	"Answer whether the receiver loads the instance variable indexed by the argument."

	self allEmbeddedBlockMethods do: [:meth |
		| scanner catcher instr scan |
		scanner _ meth scanner.
		catcher _ MessageCatcher new.
		[scanner atEnd] whileFalse: [
			instr _ scanner interpretNextInstructionFor: catcher.
			(instr selector = #send:super:numArgs: and: [instr argument = #privGetField:]) ifTrue: [
				scan _ scanner copy.
				scan pc: scan previousPc. scan pc: scan previousPc.
				instr _ scan interpretNextInstructionFor: catcher.
				(instr selector = #pushConstant: and: [instr argument = varIndex])
					ifTrue: [^ true]
			].
		].
	].
	self isReturnField ifTrue: [^ self returnField + 1 = varIndex].
	varIndex <= 16 ifTrue: [^ self scanFor: varIndex - 1].
	varIndex <= 64 ifTrue: [^ self scanLongLoad: varIndex - 1].
	^ self scanVeryLongLoad: 64 offset: varIndex - 1! !

!CompiledMethod methodsFor: 'scanning' stamp: 'ajh 5/30/2003 01:18'!
scanner

	^ InstructionStream on: self! !

!CompiledMethod methodsFor: 'scanning' stamp: 'ajh 7/7/2004 18:20'!
writesField: field 
	"Answer whether the receiver stores into the instance variable indexed by the argument."

	self allEmbeddedBlockMethods do: [:meth |
		| scanner catcher instr scan |
		scanner _ meth scanner.
		catcher _ MessageCatcher new.
		[scanner atEnd] whileFalse: [
			instr _ scanner interpretNextInstructionFor: catcher.
			(instr selector = #send:super:numArgs: and: [instr argument = #privStoreIn:field:]) ifTrue: [
				scan _ scanner copy.
				scan pc: scan previousPc. scan pc: scan previousPc.
				instr _ scan interpretNextInstructionFor: catcher.
				(instr selector = #pushConstant: and: [instr argument = field])
					ifTrue: [^ true]
			].
		].
	].
	self isQuick ifTrue: [^ false].
	field <= 8 ifTrue:
		[^ (self scanFor: 96 + field - 1) or: [self scanLongStore: field - 1]].
	field <= 64 ifTrue:
		[^ self scanLongStore: field - 1].
	^ self scanVeryLongStore: 160 offset: field - 1! !

!CompiledMethod methodsFor: 'source code management' stamp: 'ajh 3/15/2003 16:02'!
getSourceFor: selector in: class
	"Retrieve or reconstruct the source code for this method."
	| source flagByte |
	flagByte _ self last.
	(flagByte = 0
		or: [flagByte = 251 "some source-less methods have flag = 251, rest = 0"
			and: [((1 to: 3) collect: [:i | self at: self size - i]) = #(0 0 0)]])
		ifTrue:
		["No source pointer -- decompile without temp names"
		^ (self decompilerClass new decompile: selector in: class method: self)
			decompileString].
	flagByte < 252 ifTrue:
		["Magic sources -- decompile with temp names"
		^ ((self decompilerClass new withTempNames: self tempNames)
				decompile: selector in: class method: self)
			decompileString].

	"Situation normal;  read the sourceCode from the file"
	(source _ self getSourceFromFile) == nil ifFalse: [^ source].

	"Something really wrong -- decompile blind (no temps)"
	^ (self decompilerClass new decompile: selector in: class method: self)
			decompileString! !

!CompiledMethod methodsFor: 'decompiling' stamp: 'ajh 7/8/2004 19:33'!
ast
	"Return the block node for self"

	| homeMethodNode |
	homeMethodNode _ self homeMethodNode.
	self isBlockMethod ifFalse: [^ homeMethodNode].

	homeMethodNode ifNil: [^ self decompilerClass new decompileBlock: self].

	homeMethodNode compiledMethod.  "generate method"
	homeMethodNode nodesDo: [:node |
		(node isBlock and:
		 [node scope notNil "not-inlined" and:
		  [node compiledMethod = self]])
			ifTrue: [^ node]
	].

	"node not found, must have been compiled differently (compiler changed)"
	^ self decompilerClass new decompileBlock: self! !

!CompiledMethod methodsFor: 'decompiling' stamp: 'ajh 3/13/2003 21:13'!
decompilerClass

	^ self isClosureCompiled
		ifTrue: [Decompiler2]
		ifFalse: [Decompiler]! !

!CompiledMethod methodsFor: 'decompiling' stamp: 'ajh 6/28/2004 13:09'!
homeMethodNode
	"Return the parse tree of my home method"

	^ self homeMethodNodeDecompileClass: nil selector: nil! !

!CompiledMethod methodsFor: 'decompiling' stamp: 'ajh 7/7/2004 14:28'!
homeMethodNodeDecompileClass: class selector: selector
	"Return the parse tree of my home method"

	| source homeNode sel |
	(source _ self getSourceFromFile) ifNotNil: [
		sel _ selector.
		homeNode _ [self parserClass new
				parse: source readStream
				class: (class ifNil: [self sourceClass])
				noPattern: (sel = #DoIt)
				notifying: nil
				ifFail: [nil]
			] on: ParseError do: [:ex |
				sel ifNil: [sel _ #DoIt. ex retry]
					ifNotNil: [ex pass]]
	].
	^ homeNode ifNil: [
		self isBlockMethod
			ifTrue: [nil]
			ifFalse: [self decompileClass: class selector: selector]]! !

!CompiledMethod methodsFor: 'decompiling' stamp: 'ajh 3/2/2003 13:51'!
ir

	^ BytecodeDecompiler new decompile: self! !

!CompiledMethod methodsFor: 'decompiling' stamp: 'ajh 1/22/2003 16:49'!
parserClass

	^ self isClosureCompiled
		ifTrue: [Parser2]
		ifFalse: [Parser]! !


!CompiledMethod class methodsFor: 'instance creation' stamp: 'ajh 3/9/2003 15:09'!
primitive: primNum numArgs: numArgs numTemps: numTemps stackSize: stackSize literals: literals bytecodes: bytecodes trailer: trailerBytes
	"Create method with given attributes.  numTemps includes numArgs.  stackSize does not include numTemps."

	| compiledMethod |
	compiledMethod _ self
		newBytes: bytecodes size
		trailerBytes: trailerBytes 
		nArgs: numArgs
		nTemps: numTemps
		nStack: stackSize
		nLits: literals size
		primitive: primNum.
	(WriteStream with: compiledMethod)
		position: compiledMethod initialPC - 1;
		nextPutAll: bytecodes.
	literals withIndexDo: [:obj :i | compiledMethod literalAt: i put: obj].
	^ compiledMethod! !


!Compiler methodsFor: 'public access' stamp: 'ajh 7/8/2004 19:41'!
compileDoIt: textOrStream in: aContext to: receiver notifying: aRequestor ifFail: failBlock log: log
	"Compiles the sourceStream into a parse tree, then generates code into a method.  This method is then wrapped in a block with the receiver or context as the sole free variable which the method refers to.  If requestor is not nil, then it will receive a notify:at: message if there is a compile error, followed by the failBlock being executed."

	| scope parser blockNode method source |
	source _ textOrStream readStream.
	scope _ aContext
		ifNotNil: [aContext doItScope]
		ifNil: [receiver class parseScope instanceScope].
	parser _ Parser2 new.
	blockNode _ parser
			parse: source
			class: scope
			noPattern: true
			notifying: aRequestor
			ifFail: [^ failBlock value].
	method _ blockNode generate: #(0 0 0 0).

	log ifTrue: [
		method putSource: source contents
			fromParseNode: blockNode
			inFile: 2 
			withPreamble: [:file | file cr]].

	^ BlockClosure new
		env: (aContext ifNil: [receiver]);
		method: method;
		yourself! !

!Compiler methodsFor: 'public access' stamp: 'ajh 6/29/2004 14:31'!
evaluate2: textOrStream in: aContext to: receiver notifying: aRequestor ifFail: failBlock logged: logFlag

	| string |
	string _ textOrStream readStream upToEnd.
	^ (self compileDoIt: string in: aContext to: receiver notifying: aRequestor ifFail: [^ failBlock value] log: logFlag) value! !

!Compiler methodsFor: 'public access' stamp: 'ajh 7/8/2004 20:15'!
evaluate: textOrStream in: aContext to: receiver notifying: aRequestor ifFail: failBlock logged: logFlag
	"Compiles the sourceStream into a parse tree, then generates code into a 
	method. This method is then installed in the receiver's class so that it 
	can be invoked. In other words, if receiver is not nil, then the text can 
	refer to instance variables of that receiver (the Inspector uses this). If 
	aContext is not nil, the text can refer to temporaries in that context (the 
	Debugger uses this). If aRequestor is not nil, then it will receive a 
	notify:at: message before the attempt to evaluate is aborted. Finally, the 
	compiled method is invoked from here as DoIt or (in the case of 
	evaluation in aContext) DoItIn:. The method is subsequently removed 
	from the class, but this will not get done if the invocation causes an 
	error which is terminated. Such garbage can be removed by executing: 
	Smalltalk allBehaviorsDo: [:cl | cl removeSelector: #DoIt; removeSelector: 
	#DoItIn:]."

	| methodNode method value selector |
	(aContext
		ifNil: [Preferences compileBlocksAsClosures]
		ifNotNil: [aContext method isClosureCompiled]
	) ifTrue: [^ self evaluate2: textOrStream in: aContext to: receiver notifying: aRequestor ifFail: failBlock logged: logFlag].

	class _ (aContext == nil ifTrue: [receiver] ifFalse: [aContext receiver]) class.
	self from: textOrStream class: class context: aContext notifying: aRequestor.
	methodNode _ self translate: sourceStream noPattern: true ifFail:
		[^failBlock value].
	method _ methodNode generate: #(0 0 0 0).
	self interactive ifTrue:
		[method _ method copyWithTempNames: methodNode tempNames].
	
	selector _ context isNil
		ifTrue: [#DoIt]
		ifFalse: [#DoItIn:].
	class addSelectorSilently: selector withMethod: method.
	value _ context isNil
		ifTrue: [receiver DoIt]
		ifFalse: [receiver DoItIn: context].
	InMidstOfFileinNotification signal 
		ifFalse: [class basicRemoveSelector: selector].
	logFlag ifTrue: [SystemChangeNotifier uniqueInstance evaluated: sourceStream contents context: aContext].
	^ value! !

!Compiler methodsFor: 'private' stamp: 'ajh 3/6/2003 01:04'!
dialectParserClass

	^ self parserClass = Parser2
		ifTrue: [self toDo]
		ifFalse: [DialectParser]! !

!Compiler methodsFor: 'private' stamp: 'ajh 7/8/2004 17:47'!
parserClass: aParserClass

	parserClass _ aParserClass.
! !


!Compiler class methodsFor: 'accessing' stamp: 'ajh 1/20/2002 18:57'!
parserClass
	"Return a parser class to use for parsing method headers."

	^ Preferences compileBlocksAsClosures
		ifTrue: [Parser2]
		ifFalse: [Parser]! !

!Compiler class methodsFor: 'as yet unclassified' stamp: 'ajh 3/26/2003 00:39'!
initialize

	Preferences
		addPreference: #compileBlocksAsClosures
		category: #general
		default: false
		balloonHelp: 'If true, blocks ([...]) will be compiled as BlockClosures instead of BlockContexts.  BlockClosures are independent of their home context but are a little slower (for now).  Only newly compiled methods will be affected by this preference.'
! !


!Debugger methodsFor: 'private' stamp: 'ajh 7/7/2004 15:48'!
contextStackIndex: anInteger oldContextWas: oldContext 
	"Change the context stack index to anInteger, perhaps in response to user selection."

	| newMethod c |
	contextStackIndex := anInteger.
	anInteger = 0
		ifTrue: [currentCompiledMethod := theMethodNode := tempNames := sourceMap := contents := nil.
			self changed: #contextStackIndex.
			self decorateButtons.
			self contentsChanged.
			contextVariablesInspector object: nil.
			self receiverInspectorObject: self receiver context: nil.
			^ self].
	(newMethod := oldContext == nil
					or: [oldContext method ~~ (currentCompiledMethod := self selectedContext method)])
		ifTrue: [tempNames := sourceMap := nil.
			theMethodNode := Preferences browseWithPrettyPrint
				ifTrue: [ 	self selectedContext methodNodeFormattedAndDecorated: Preferences colorWhenPrettyPrinting ]
				ifFalse: [	self selectedContext methodNode ].
			contents := self selectedMessage.
			self contentsChanged.
			self pcRange
			"will compute tempNamesunless noFrills"].
	self changed: #contextStackIndex.
	self decorateButtons.
	tempNames == nil
		ifTrue: [tempNames := self selectedClassOrMetaClass parserClass new parseArgsAndTemps: contents notifying: nil].
	contextVariablesInspector object: (c _ self selectedContext).
	self receiverInspectorObject: self receiver context: c.
	newMethod
		ifFalse: [self changed: #contentsSelection]! !

!Debugger methodsFor: 'private' stamp: 'ajh 7/7/2004 15:56'!
receiverInspectorObject: obj context: ctxt

	"set context before object so it can refer to context when building field list"
	receiverInspector context: ctxt.
	receiverInspector object: obj.
! !


!InstructionStream methodsFor: 'decoding' stamp: 'ajh 3/2/2003 14:06'!
interpret

	[self atEnd] whileFalse: [self interpretNextInstructionFor: self]! !

!InstructionStream methodsFor: 'scanning' stamp: 'ajh 7/7/2004 18:21'!
previousPc

	| currentPc dummy prevPc |
	currentPc _ pc.
	pc _ self method initialPC.
	dummy _ MessageCatcher new.
	[pc = currentPc] whileFalse: [
		prevPc _ pc.
		self interpretNextInstructionFor: dummy.
	].
	^ prevPc! !


!ContextPart methodsFor: 'accessing' stamp: 'ajh 6/28/2004 14:56'!
methodNode

	| selector methodClass |
	self method isBlockMethod ifTrue: [^ self method ast].
	selector _ self receiver class
		selectorAtMethod: self method
		setClass: [:mclass | methodClass _ mclass].
	^ self method homeMethodNodeDecompileClass: methodClass selector: selector! !


!MethodContext methodsFor: 'closure support' stamp: 'ajh 7/8/2004 17:43'!
doItScope
	"scope (environment) for expressions executed within a method context. self will be the receiver of the do-it method. We want temp vars directly accessible"

	^ self methodNode scope asDoItScope! !


!OrderedCollection methodsFor: 'adding' stamp: 'ajh 5/22/2003 12:03'!
at: index ifAbsentPut: block
	"Return value at index, however, if value does not exist (nil or out of bounds) then add block's value at index (growing self if necessary)"

	| v |
	index <= self size ifTrue: [
		^ (v _ self at: index)
			ifNotNil: [v]
			ifNil: [self at: index put: block value]
	].
	[self size < index] whileTrue: [self add: nil].
	^ self at: index put: block value! !


!ParseNode methodsFor: 'testing' stamp: 'ajh 6/29/2004 14:13'!
isDoIt
	"polymorphic with RBNodes; called by debugger"

	^ false! !

!ParseNode methodsFor: 'testing' stamp: 'ajh 3/24/2003 16:16'!
isJust: node

	^ false! !

!ParseNode methodsFor: 'converting' stamp: 'ajh 3/24/2003 16:25'!
ifNilReceiver

	^ self! !


!MethodNode methodsFor: 'code generation' stamp: 'ajh 3/24/2003 14:55'!
generate: trailer 

	Preferences compileBlocksAsClosures ifTrue: [
		^ (Parser2 new
			parse: self decompileString
			class: self encoder classEncoding
		   ) generate: trailer
	].

	^ self generateNative: trailer! !

!MethodNode methodsFor: 'code generation' stamp: 'ajh 3/24/2003 14:52'!
sourceMap
	"Answer a SortedCollection of associations of the form: pc (byte offset in 
	me) -> sourceRange (an Interval) in source text."

	self generateNative: #(0 0 0 0).
	^encoder sourceMap! !


!Parser methodsFor: 'public access' stamp: 'ajh 6/29/2004 14:31'!
parse: sourceStream class: class noPattern: noPattern notifying: req ifFail: aBlock

	^ self parse: sourceStream class: class noPattern: noPattern context: nil notifying: req ifFail: aBlock! !


!RBProgramNode methodsFor: 'accessing' stamp: 'ajh 3/17/2003 00:28'!
comment

	^ (comments isNil or: [comments isEmpty])
		ifTrue: [nil]
		ifFalse: [comments first]! !

!RBProgramNode methodsFor: 'accessing' stamp: 'ajh 3/15/2003 15:17'!
debugHighlightStart

	^ self start! !

!RBProgramNode methodsFor: 'accessing' stamp: 'ajh 3/15/2003 15:18'!
debugHighlightStop

	^ self stop! !

!RBProgramNode methodsFor: 'testing' stamp: 'ajh 2/25/2003 14:34'!
isArray
	^false! !

!RBProgramNode methodsFor: 'testing' stamp: 'ajh 6/29/2004 14:12'!
isDoIt

	^ false! !

!RBProgramNode methodsFor: 'testing' stamp: 'ajh 3/3/2003 22:28'!
isLiteral: valueTestBlock
	^false! !

!RBProgramNode methodsFor: 'querying' stamp: 'ajh 2/27/2003 22:40'!
root

	^ parent
		ifNil: [self]
		ifNotNil: [parent root]! !

!RBProgramNode methodsFor: 'replacing' stamp: 'ajh 3/13/2003 16:09'!
adjustPositionsAfter: sourcePos by: delta
	"Slide token positions after sourcePos by delta"

	self children do: [:node |
		node adjustPositionsAfter: sourcePos by: delta]! !

!RBProgramNode methodsFor: 'inline' stamp: 'ajh 2/25/2003 19:48'!
isInline

	^ false! !

!RBProgramNode methodsFor: 'semantics' stamp: 'ajh 6/30/2004 14:08'!
owningBlock

	^ parent owningBlock! !

!RBProgramNode methodsFor: 'semantics' stamp: 'ajh 3/13/2003 04:19'!
owningScope

	^ parent owningScope! !

!RBProgramNode methodsFor: 'decompiling' stamp: 'ajh 3/15/2003 14:57'!
decompileString

	^ self formattedCode! !

!RBProgramNode methodsFor: 'decompiling' stamp: 'ajh 3/4/2003 00:50'!
isCaseBranch

	^ false! !

!RBProgramNode methodsFor: 'decompiling' stamp: 'ajh 3/2/2003 23:22'!
isDup

	^ false! !

!RBProgramNode methodsFor: 'decompiling' stamp: 'ajh 3/2/2003 23:22'!
isGoto

	^ false! !

!RBProgramNode methodsFor: 'decompiling' stamp: 'ajh 3/1/2003 20:12'!
isIf

	^ false! !

!RBProgramNode methodsFor: 'decompiling' stamp: 'ajh 3/2/2003 23:22'!
isLabel

	^ false! !

!RBProgramNode methodsFor: 'decompiling' stamp: 'ajh 3/2/2003 23:22'!
isPop

	^ false! !

!RBProgramNode methodsFor: 'decompiling' stamp: 'ajh 3/3/2003 18:42'!
isPseudo

	^ false! !

!RBProgramNode methodsFor: 'decompiling' stamp: 'ajh 3/23/2003 22:23'!
isPseudoSend

	^ false! !


!RBArrayNode methodsFor: 'testing' stamp: 'ajh 2/25/2003 14:34'!
isArray

	^ true! !

!RBArrayNode methodsFor: 'initialization' stamp: 'ajh 3/4/2003 02:04'!
leftBrace: leftBrace0  rightBrace: rightBrace0  statements: statements0
	self leftBrace: leftBrace0.
	self rightBrace: rightBrace0.
	self statements: statements0.! !

!RBArrayNode methodsFor: 'visitor' stamp: 'ajh 3/17/2003 00:25'!
acceptVisitor: aProgramNodeVisitor
	^ aProgramNodeVisitor acceptArrayNode: self! !

!RBArrayNode methodsFor: 'replacing' stamp: 'ajh 3/19/2003 16:14'!
adjustPositionsAfter: sourcePos by: delta
	"Slide token positions after sourcePos by delta"

	self leftBrace: leftBrace + delta.
	self rightBrace: rightBrace + delta.
	super adjustPositionsAfter: sourcePos by: delta.
! !


!RBArrayNode class methodsFor: 'instance creation' stamp: 'ajh 3/4/2003 02:03'!
statements: statements
	^ self new statements: statements! !


!RBBlockNode methodsFor: 'replacing' stamp: 'ajh 3/19/2003 16:15'!
adjustPositionsAfter: sourcePos by: delta
	"Slide token positions after sourcePos by delta"

	self left: left + delta.
	self right: right + delta.
	super adjustPositionsAfter: sourcePos by: delta.
! !

!RBBlockNode methodsFor: 'printing' stamp: 'ajh 3/17/2003 09:12'!
sourceText

	| text |
	self parent ifNil: [^ self formattedCode asText].
	text _ [self root sourceText]
		on: Error
		do: [^ self formattedCode asText].
	text addAttribute: TextColor gray from: 1 to: self start - 1.
	text addAttribute: TextColor gray from: self stop + 1 to: text size.
	^ text! !

!RBBlockNode methodsFor: 'inline' stamp: 'ajh 3/13/2003 02:43'!
isInlined

	(parent isMessage and: [parent isInlineAndOr]) ifTrue: [^ true].
	(parent isMessage and: [parent isInlineIf]) ifTrue: [^ true].
	(parent isMessage and: [parent isInlineIfNil]) ifTrue: [^ true].
	(parent isMessage and: [parent isInlineToDo]) ifTrue: [^ true].
	(parent isMessage and: [parent isInlineWhile]) ifTrue: [^ true].
	(parent isMessage and: [parent parent isArray and: [parent parent parent isMessage and: [parent parent parent isInlineCase]]]) ifTrue: [^ true].
	(parent isMessage and: [parent isInlineCase]) ifTrue: [^ true].  "otherwise branch"
	^ false! !

!RBBlockNode methodsFor: 'semantics' stamp: 'ajh 7/8/2004 20:56'!
freeNames
	"Filter out hidden ones that have space in there name such as 'top env'"

	^ ((self freeVars collect: [:var | var name])
		reject: [:name | name includes: $ ]) asSortedCollection! !

!RBBlockNode methodsFor: 'semantics' stamp: 'ajh 7/8/2004 20:59'!
freeVars
	"Return children variable node bindings that refer to variables outside my scope (ignoring global vars)"

	| freeVars |
	freeVars _ Set new.
	scope _ self owningScope.
	self nodesDo: [:node | | var |
		(node isVariable or: [node isReturn and: [node binding notNil]]) ifTrue: [
			var _ node binding.
			(scope hasOuter: var scope) ifTrue: [
				var isGlobal ifFalse: [
					freeVars add: var]]]].
	^ freeVars! !

!RBBlockNode methodsFor: 'semantics' stamp: 'ajh 6/30/2004 14:07'!
owningBlock

	^ self! !

!RBBlockNode methodsFor: 'semantics' stamp: 'ajh 7/8/2004 10:43'!
owningScope

	^ scope ifNil: ["inlined" ^ parent owningScope]! !

!RBBlockNode methodsFor: 'semantics' stamp: 'ajh 2/26/2003 15:52'!
scope

	^ scope! !

!RBBlockNode methodsFor: 'semantics' stamp: 'ajh 2/26/2003 15:53'!
scope: aSemClosureScope

	scope _ aSemClosureScope! !

!RBBlockNode methodsFor: 'translate' stamp: 'ajh 6/28/2004 13:52'!
compiledMethod

	^ self ir compiledMethod! !

!RBBlockNode methodsFor: 'translate' stamp: 'ajh 3/10/2003 20:23'!
generate: trailer

	^ self generateIR compiledMethodWith: trailer! !

!RBBlockNode methodsFor: 'translate' stamp: 'ajh 6/23/2004 19:51'!
generateIR

	^ ir _ ASTTranslator new
		translateBlockNode: self;
		ir! !

!RBBlockNode methodsFor: 'translate' stamp: 'ajh 3/10/2003 20:24'!
ir

	^ ir ifNil: [self generateIR]! !

!RBBlockNode methodsFor: 'translate' stamp: 'ajh 3/3/2003 15:31'!
privIR: irMethod

	ir _ irMethod! !

!RBBlockNode methodsFor: 'debugging' stamp: 'ajh 2/28/2003 00:18'!
sourceMap
	"Return a mapping from bytecode pcs to source code ranges"

	^ self ir sourceMap! !

!RBBlockNode methodsFor: 'debugging' stamp: 'ajh 6/29/2004 16:05'!
tempNames
	"All temp names in context order"

	^ self scope tempVars allButFirst "without self" collect: [:var | var name]! !


!RBCascadeNode methodsFor: 'accessing' stamp: 'ajh 2/25/2003 01:12'!
receiver

	^ self messages first receiver! !


!RBDoItNode methodsFor: 'comparing' stamp: 'ajh 2/26/2003 18:35'!
= anObject 
	self == anObject ifTrue: [^true].
	self class = anObject class ifFalse: [^false].
	(self body = anObject body) ifFalse: [^false].
	^true! !

!RBDoItNode methodsFor: 'comparing' stamp: 'ajh 2/26/2003 18:35'!
equalTo: anObject withMapping: aDictionary 
	self class = anObject class ifFalse: [^false].
	(self body equalTo: anObject body withMapping: aDictionary) 
		ifFalse: [^false].
	^self primitiveSources = anObject primitiveSources! !

!RBDoItNode methodsFor: 'comparing' stamp: 'ajh 2/26/2003 18:36'!
hash
	^ self body hash! !

!RBDoItNode methodsFor: 'visitor' stamp: 'ajh 2/26/2003 18:31'!
acceptVisitor: aProgramNodeVisitor 
	^aProgramNodeVisitor acceptDoItNode: self! !

!RBDoItNode methodsFor: 'accessing' stamp: 'ajh 2/26/2003 18:22'!
addNode: aNode 
	^body addNode: aNode! !

!RBDoItNode methodsFor: 'accessing' stamp: 'ajh 2/26/2003 18:22'!
addReturn
	body addReturn! !

!RBDoItNode methodsFor: 'accessing' stamp: 'ajh 2/26/2003 18:22'!
addSelfReturn
	^body addSelfReturn! !

!RBDoItNode methodsFor: 'accessing' stamp: 'ajh 2/26/2003 18:22'!
body
	^body! !

!RBDoItNode methodsFor: 'accessing' stamp: 'ajh 2/26/2003 18:22'!
body: stmtsNode 
	body := stmtsNode.
	body parent: self! !

!RBDoItNode methodsFor: 'accessing' stamp: 'ajh 2/26/2003 18:28'!
children
	^ {self body}! !

!RBDoItNode methodsFor: 'accessing' stamp: 'ajh 2/26/2003 18:22'!
primitiveSources
	^self tags 
		collect: [:each | self source copyFrom: each first to: each last]! !

!RBDoItNode methodsFor: 'accessing' stamp: 'ajh 2/26/2003 18:22'!
source
	^source! !

!RBDoItNode methodsFor: 'accessing' stamp: 'ajh 2/26/2003 18:22'!
source: anObject
	source := anObject! !

!RBDoItNode methodsFor: 'accessing' stamp: 'ajh 2/26/2003 18:22'!
start
	^1! !

!RBDoItNode methodsFor: 'accessing' stamp: 'ajh 2/26/2003 18:22'!
stop
	^source size! !

!RBDoItNode methodsFor: 'accessing' stamp: 'ajh 2/26/2003 18:22'!
tags
	^tags isNil ifTrue: [#()] ifFalse: [tags]! !

!RBDoItNode methodsFor: 'accessing' stamp: 'ajh 2/26/2003 18:22'!
tags: aCollectionOfIntervals 
	tags := aCollectionOfIntervals! !

!RBDoItNode methodsFor: 'matching' stamp: 'ajh 2/26/2003 18:24'!
copyInContext: aDictionary 
	^(self class new)
		body: (body copyInContext: aDictionary);
		source: (aDictionary at: '-source-');
		yourself! !

!RBDoItNode methodsFor: 'matching' stamp: 'ajh 2/26/2003 18:28'!
match: aNode inContext: aDictionary 
	self class == aNode class ifFalse: [^false].
	aDictionary at: '-source-' put: aNode source.
	^ body match: aNode body inContext: aDictionary! !

!RBDoItNode methodsFor: 'testing' stamp: 'ajh 6/29/2004 14:11'!
isDoIt

	^ true! !

!RBDoItNode methodsFor: 'testing' stamp: 'ajh 2/26/2003 18:22'!
isLast: aNode 
	^body isLast: aNode! !

!RBDoItNode methodsFor: 'testing' stamp: 'ajh 2/26/2003 18:22'!
lastIsReturn
	^body lastIsReturn! !

!RBDoItNode methodsFor: 'testing' stamp: 'ajh 2/26/2003 18:22'!
references: aVariableName 
	^body references: aVariableName! !

!RBDoItNode methodsFor: 'testing' stamp: 'ajh 2/26/2003 18:22'!
uses: aNode 
	^body == aNode and: [aNode lastIsReturn]! !

!RBDoItNode methodsFor: 'copying' stamp: 'ajh 2/26/2003 18:30'!
postCopy
	super postCopy.
	body := body copy.
! !

!RBDoItNode methodsFor: 'printing' stamp: 'ajh 2/26/2003 18:22'!
printOn: aStream
	aStream nextPutAll: self formattedCode! !

!RBDoItNode methodsFor: 'printing' stamp: 'ajh 6/29/2004 14:31'!
sourceText

	^ (self source ifNil: [self formattedCode]) asText! !

!RBDoItNode methodsFor: 'replacing' stamp: 'ajh 2/26/2003 18:57'!
replaceNode: aNode withNode: anotherNode
	aNode == body ifTrue: [self body: anotherNode].
! !

!RBDoItNode methodsFor: 'semantics' stamp: 'ajh 7/8/2004 20:56'!
freeNames
	"Filter out hidden ones that have space in there name such as 'top env'"

	^ ((self freeVars collect: [:var | var name])
		reject: [:name | name includes: $ ]) asSortedCollection! !

!RBDoItNode methodsFor: 'semantics' stamp: 'ajh 7/8/2004 20:59'!
freeVars
	"Return children variable node bindings that refer to variables outside my scope (ignoring global vars)"

	| freeVars |
	freeVars _ Set new.
	scope _ self owningScope.
	self nodesDo: [:node | | var |
		(node isVariable or: [node isReturn and: [node binding notNil]]) ifTrue: [
			var _ node binding.
			(scope hasOuter: var scope) ifTrue: [
				var isGlobal ifFalse: [
					freeVars add: var]]]].
	^ freeVars! !

!RBDoItNode methodsFor: 'semantics' stamp: 'ajh 6/30/2004 14:07'!
owningBlock

	^ self! !

!RBDoItNode methodsFor: 'semantics' stamp: 'ajh 3/13/2003 04:25'!
owningScope

	^ scope! !

!RBDoItNode methodsFor: 'semantics' stamp: 'ajh 3/16/2003 08:33'!
scope

	^ scope ifNil: [
		self verifyIn: nil parseScope.
		scope
	  ]! !

!RBDoItNode methodsFor: 'semantics' stamp: 'ajh 3/17/2003 15:34'!
scope: aSemScope

	scope _ aSemScope! !

!RBDoItNode methodsFor: 'semantics' stamp: 'ajh 6/23/2004 19:50'!
verifyIn: classOrScope
	"Look up vars in classOrScope.  My tree will be annotated with bindings to LexicalScopes and ScopeVars."

	ASTChecker new
		scope: classOrScope parseScope;
		visitNode: self! !

!RBDoItNode methodsFor: 'translate' stamp: 'ajh 6/28/2004 13:52'!
compiledMethod

	^ self ir compiledMethod! !

!RBDoItNode methodsFor: 'translate' stamp: 'ajh 3/10/2003 20:23'!
generate: trailer

	^ self generateIR compiledMethodWith: trailer! !

!RBDoItNode methodsFor: 'translate' stamp: 'ajh 6/23/2004 19:52'!
generateIR

	^ ir _ ASTTranslator new
		visitNode: self;
		ir! !

!RBDoItNode methodsFor: 'translate' stamp: 'ajh 3/10/2003 20:25'!
ir

	^ ir ifNil: [self generateIR]! !

!RBDoItNode methodsFor: 'debugging' stamp: 'ajh 6/29/2004 14:24'!
sourceMap
	"Return a mapping from bytecode pcs to source code ranges"

	^ self ir sourceMap! !

!RBDoItNode methodsFor: 'debugging' stamp: 'ajh 6/29/2004 16:06'!
tempNames
	"All temp names in context order"

	^ self scope tempVars allButFirst "without receiver" collect: [:var | var name]! !


!RBDoItNode class methodsFor: 'instance creation' stamp: 'ajh 3/11/2003 19:08'!
body: aSequenceNode

	^ self new body: aSequenceNode! !


!RBLiteralNode methodsFor: 'accessing' stamp: 'ajh 2/27/2003 17:24'!
value

	^ value == Null
		ifTrue: [token realValue]
		ifFalse: [value]! !

!RBLiteralNode methodsFor: 'initialize-release' stamp: 'ajh 2/27/2003 17:23'!
initialize

	value _ Null! !

!RBLiteralNode methodsFor: 'initialize-release' stamp: 'ajh 2/27/2003 17:22'!
value: object

	value _ object! !

!RBLiteralNode methodsFor: 'testing' stamp: 'ajh 3/3/2003 22:29'!
isLiteral: valueTestBlock

	^ valueTestBlock value: self value! !

!RBLiteralNode methodsFor: 'replacing' stamp: 'ajh 3/13/2003 16:11'!
adjustPositionsAfter: sourcePos by: delta
	"Slide token positions after sourcePos by delta"

	token start > sourcePos ifTrue: [
		token start: token start + delta]! !


!RBLiteralNode class methodsFor: 'instance creation' stamp: 'ajh 2/27/2003 17:23'!
initialize

	Null _ Object new! !

!RBLiteralNode class methodsFor: 'instance creation' stamp: 'ajh 2/27/2003 17:22'!
literalToken: aLiteralToken value: object
	^self new literalToken: aLiteralToken; value: object! !


!RBMessageNode methodsFor: 'accessing' stamp: 'ajh 3/15/2003 15:18'!
debugHighlightStart

	^ self selectorParts first start! !

!RBMessageNode methodsFor: 'accessing' stamp: 'ajh 3/15/2003 15:19'!
debugHighlightStop

	^ self stopWithoutParentheses! !

!RBMessageNode methodsFor: 'accessing' stamp: 'ajh 3/11/2003 23:16'!
selectorPartIntervals

	^ selectorParts collect: [:token | token sourceInterval]! !

!RBMessageNode methodsFor: 'accessing' stamp: 'ajh 3/11/2003 22:48'!
selectorString

	| selectorStream |
	selectorStream := WriteStream on: (String new: 50).
	selectorParts do: [:each | selectorStream nextPutAll: each value].
	^ selectorStream contents! !

!RBMessageNode methodsFor: 'replacing' stamp: 'ajh 3/13/2003 16:12'!
adjustPositionsAfter: sourcePos by: delta
	"Slide token positions after sourcePos by delta"

	selectorParts do: [:token |
		token start > sourcePos ifTrue: [
			token start: token start + delta]
	].
	super adjustPositionsAfter: sourcePos by: delta.
! !

!RBMessageNode methodsFor: 'replacing' stamp: 'ajh 3/17/2003 13:11'!
changeSelectorParts: tokenCollection

	| root oldToken newToken |
	root _ self root.
	1 to: selectorParts size do: [:i |
		oldToken _ selectorParts at: i.
		newToken _ tokenCollection at: i.
		root adjustPositionsAfter: oldToken stop
			by: newToken stop - oldToken stop.
		selectorParts at: i put: newToken.
	].
	selector _ nil.
! !

!RBMessageNode methodsFor: 'testing' stamp: 'ajh 2/25/2003 17:16'!
lastIsReturn

	^ ((#(ifTrue:ifFalse: ifFalse:ifTrue: ifNil:ifNotNil: ifNotNil:ifNil:) includes: self selector)
		and: [arguments first isBlock and: 
			[arguments first body lastIsReturn
				and: [arguments last isBlock and: [arguments last body lastIsReturn]]]])
	  or: [(#(caseOf: caseOf:otherwise:) includes: self selector)
		and: [arguments first isArray and: [arguments first statements allSatisfy: [:assocMessage | assocMessage arguments first isBlock and: [assocMessage arguments first body lastIsReturn]]]
			and: [selector == #caseOf: or: [arguments second isBlock and: [arguments second body lastIsReturn]]]]]! !

!RBMessageNode methodsFor: 'private' stamp: 'ajh 3/11/2003 23:40'!
selectorParts: tokenCollection 
	selectorParts := tokenCollection.
	selector _ nil.
! !

!RBMessageNode methodsFor: 'inline' stamp: 'ajh 2/25/2003 19:47'!
isInline

	self isInlineAndOr ifTrue: [^ true].
	self isInlineCase ifTrue: [^ true].
	self isInlineIf ifTrue: [^ true].
	self isInlineIfNil ifTrue: [^ true].
	self isInlineToDo ifTrue: [^ true].
	self isInlineWhile ifTrue: [^ true].
	^ false! !

!RBMessageNode methodsFor: 'inline' stamp: 'ajh 3/14/2003 21:22'!
isInlineAndOr

	self receiver isBlock ifTrue: [^ false].
	self isCascaded ifTrue: [^ false].
	(#(and: or:) includes: self selectorString) ifFalse: [^ false].
	self arguments first isBlock ifFalse: [^ false].
	self arguments first arguments isEmpty ifFalse: [self notify: 'and: (or:) takes zero-arg block'. ^ false].
	^ true! !

!RBMessageNode methodsFor: 'inline' stamp: 'ajh 3/14/2003 21:23'!
isInlineCase

	self isCascaded ifTrue: [^ false].
	(#(caseOf: caseOf:otherwise:) includes: self selectorString) ifFalse: [^ false].
	self arguments size = 2 ifTrue: [  "otherwise block"
		self arguments last isBlock ifFalse: [^ false]].
	self arguments first isArray ifFalse: [^ false].
	self arguments first statements do: [:assoc |
		(assoc isMessage and: [assoc selectorString = #->]) ifFalse: [^ false].
		assoc receiver isBlock ifFalse: [^ false].
		assoc receiver arguments isEmpty ifFalse: [self notify: 'caseOf: takes zero-arg blocks'. ^ false].
		assoc arguments first isBlock ifFalse: [^ false].
		assoc arguments first arguments isEmpty ifFalse: [self notify: 'caseOf: takes zero-arg blocks'].
	].
	^ true! !

!RBMessageNode methodsFor: 'inline' stamp: 'ajh 3/14/2003 21:23'!
isInlineIf

	self receiver isBlock ifTrue: [^ false].
	self isCascaded ifTrue: [^ false].
	(#(ifTrue: ifFalse: ifTrue:ifFalse: ifFalse:ifTrue:) includes: self selectorString) ifFalse: [^ false].
	self arguments do: [:node | node isBlock ifFalse: [^ false]].
	self arguments do: [:block |
		block arguments isEmpty ifFalse: [
			self notify: 'ifTrue:ifFalse: takes zero-arg blocks'.
			^ false
		]
	].
	^ true! !

!RBMessageNode methodsFor: 'inline' stamp: 'ajh 3/14/2003 21:24'!
isInlineIfNil

	| assertNone assertOneOrNone |
	self receiver isBlock ifTrue: [^ false].
	self isCascaded ifTrue: [^ false].
	(#(ifNil: ifNotNil: ifNil:ifNotNil: ifNotNil:ifNil:) includes: self selectorString) ifFalse: [^ false].
	self arguments do: [:node | node isBlock ifFalse: [^ false]].
	assertNone _ [:block | 
		block arguments isEmpty ifFalse: [self notify: 'ifNil: takes zero-arg block'. ^ false]
	].
	assertOneOrNone _ [:block | 
		block arguments size > 1 ifTrue: [self notify: 'ifNotNil: takes zero- or one-arg block'. ^ false]
	].
	self selectorString caseOf: {
		[#ifNil:] 		 	-> [assertNone value: self arguments first].
		[#ifNil:ifNotNil:] 	-> [assertNone value: self arguments first. 
							   assertOneOrNone value: self arguments last].
		[#ifNotNil:] 		  	-> [assertOneOrNone value: self arguments first].
		[#ifNotNil:ifNil:] 	-> [assertOneOrNone value: self arguments first. 
							   assertNone value: self arguments last]
	}.
	^ true! !

!RBMessageNode methodsFor: 'inline' stamp: 'ajh 3/17/2003 09:02'!
isInlineToDo

	| block step |
	self receiver isBlock ifTrue: [^ false].
	self isCascaded ifTrue: [^ false].
	(#(to:do: to:by:do:) includes: self selectorString) ifFalse: [^ false].
	self arguments first isBlock ifTrue: [^ false].
	block _ self arguments last.
	block isBlock ifFalse: [^ false].
	block arguments size = 1 ifFalse: [
		self notify: 'to:do: block must take one arg'. ^ false].
	(ParseTreeSearcher new
		matches: block arguments first name , ' := `@object' do: [:n :a | true];
		executeTree: block initialAnswer: false) ifTrue: [^ false].
	self arguments size = 3 "to:by:do:" ifTrue: [
		step _ self arguments second.
		step isLiteral ifFalse: [^ false].
		step value = 0 ifTrue: [self notify: 'by: step can''t be zero'. ^ false].
	].
	^ true! !

!RBMessageNode methodsFor: 'inline' stamp: 'ajh 3/14/2003 21:25'!
isInlineWhile

	self isCascaded ifTrue: [^ false].
	(#(whileFalse: whileTrue: whileFalse whileTrue) includes: self selectorString) ifFalse: [^ false].
	self receiver isBlock ifFalse: [^ false].
	self receiver arguments isEmpty ifFalse: [self notify: 'while receiver block must have no arguments'. ^ false].
	self arguments isEmpty ifFalse: [
		self arguments first isBlock ifFalse: [^ false].
		self arguments first arguments isEmpty ifFalse: [self notify: 'while takes a zero-arg block as its argument'. ^ false].
	].
	^ true! !


!RBMethodNode methodsFor: 'accessing' stamp: 'ajh 3/11/2003 19:58'!
methodPatternStop

	^ self arguments isEmpty
		ifTrue: [self selectorParts first stop]
		ifFalse: [self arguments last stop]! !

!RBMethodNode methodsFor: 'accessing' stamp: 'ajh 3/19/2003 22:02'!
primitiveSources

	| tgs text |
	tgs _ self tags.
	tgs isEmpty ifTrue: [
		text _ self primitiveText.
		text isEmpty ifTrue: [^ #()].
		^ {text}
	].
	^ tgs collect: [:each | self source copyFrom: each first to: each last]! !

!RBMethodNode methodsFor: 'accessing' stamp: 'ajh 3/11/2003 18:32'!
primitiveStartPosition

	| set |
	set _ self tags.
	set isEmpty ifTrue: [^ 0].
	set size > 1 ifTrue: [self error: 'only one primitive string expected'].
	^ set first first! !

!RBMethodNode methodsFor: 'accessing' stamp: 'ajh 3/19/2003 22:02'!
primitiveText

	| set |
	self tags isEmpty ifTrue: [
		^ self primitiveNode
			ifNil: ['']
			ifNotNil: [self primitiveNode sourceText]
	].
	set _ self primitiveSources.
	set size > 1 ifTrue: [self error: 'only one primitive string expected'].
	^ set first
! !

!RBMethodNode methodsFor: 'printing' stamp: 'ajh 2/27/2003 22:44'!
sourceText

	^ (self source ifNil: [self formattedCode]) asText! !

!RBMethodNode methodsFor: 'replacing' stamp: 'ajh 3/13/2003 16:13'!
adjustPositionsAfter: sourcePos by: delta
	"Slide token positions after sourcePos by delta"

	selectorParts do: [:token |
		token start > sourcePos ifTrue: [
			token start: token start + delta]
	].
	super adjustPositionsAfter: sourcePos by: delta.
! !

!RBMethodNode methodsFor: 'copying' stamp: 'ajh 3/3/2003 15:28'!
asBlock

	^ (RBBlockNode
		arguments: arguments
		body: body)
		privIR: ir;
		scope: scope! !

!RBMethodNode methodsFor: 'semantics' stamp: 'ajh 7/8/2004 20:56'!
freeNames
	"Filter out hidden ones that have space in there name such as 'top env'"

	^ ((self freeVars collect: [:var | var name])
		reject: [:name | name includes: $ ]) asSortedCollection! !

!RBMethodNode methodsFor: 'semantics' stamp: 'ajh 7/8/2004 20:59'!
freeVars
	"Return children variable node bindings that refer to variables outside my scope (ignoring global vars)"

	| freeVars |
	freeVars _ Set new.
	scope _ self owningScope.
	self nodesDo: [:node | | var |
		(node isVariable or: [node isReturn and: [node binding notNil]]) ifTrue: [
			var _ node binding.
			(scope hasOuter: var scope) ifTrue: [
				var isGlobal ifFalse: [
					freeVars add: var]]]].
	^ freeVars! !

!RBMethodNode methodsFor: 'semantics' stamp: 'ajh 6/30/2004 14:07'!
owningBlock

	^ self! !

!RBMethodNode methodsFor: 'semantics' stamp: 'ajh 3/13/2003 04:25'!
owningScope

	^ scope! !

!RBMethodNode methodsFor: 'semantics' stamp: 'ajh 3/11/2003 18:27'!
primitiveNode

	^ primitiveNode ifNil: [PrimitiveNode null]! !

!RBMethodNode methodsFor: 'semantics' stamp: 'ajh 3/11/2003 18:18'!
primitiveNode: aPrimitiveNode

	primitiveNode _ aPrimitiveNode! !

!RBMethodNode methodsFor: 'semantics' stamp: 'ajh 3/16/2003 08:32'!
scope

	^ scope ifNil: [
		self verifyIn: nil parseScope.
		scope
	  ]! !

!RBMethodNode methodsFor: 'semantics' stamp: 'ajh 2/26/2003 15:46'!
scope: aSemMethodScope

	scope _ aSemMethodScope! !

!RBMethodNode methodsFor: 'semantics' stamp: 'ajh 6/23/2004 19:51'!
verifyIn: classOrScope
	"Look up vars in classOrScope.  My tree will be annotated with bindings to LexicalScopes and ScopeVars."

	ASTChecker new
		scope: classOrScope parseScope;
		visitNode: self! !

!RBMethodNode methodsFor: 'translate' stamp: 'ajh 6/28/2004 13:52'!
compiledMethod

	^ self ir compiledMethod! !

!RBMethodNode methodsFor: 'translate' stamp: 'ajh 3/10/2003 20:21'!
generate: trailer

	^ self generateIR compiledMethodWith: trailer! !

!RBMethodNode methodsFor: 'translate' stamp: 'ajh 6/23/2004 19:52'!
generateIR

	^ ir _ ASTTranslator new
		visitNode: self;
		ir! !

!RBMethodNode methodsFor: 'translate' stamp: 'ajh 3/10/2003 20:20'!
ir

	^ ir ifNil: [self generateIR]! !

!RBMethodNode methodsFor: 'translate' stamp: 'ajh 3/3/2003 12:07'!
privIR: irMethod

	ir _ irMethod! !

!RBMethodNode methodsFor: 'debugging' stamp: 'ajh 2/27/2003 23:58'!
sourceMap
	"Return a mapping from bytecode pcs to source code ranges"

	^ self ir sourceMap! !

!RBMethodNode methodsFor: 'debugging' stamp: 'ajh 6/29/2004 16:06'!
tempNames
	"All temp names in context order"

	^ self scope tempVars allButFirst "without self" collect: [:var | var name]! !


!RBProgramNodeVisitor methodsFor: 'visitor-double dispatching' stamp: 'ajh 2/26/2003 18:34'!
acceptDoItNode: aDoItNode 
	self visitNode: aDoItNode body! !

!RBProgramNodeVisitor methodsFor: 'visitor-double dispatching' stamp: 'ajh 3/3/2003 12:43'!
acceptPseudoNode: aVariableNode! !


!RBFormatter methodsFor: 'visitor-double dispatching' stamp: 'ajh 3/19/2003 14:13'!
acceptArrayNode: anArrayNode

	anArrayNode start ifNil: [anArrayNode leftBrace: self fullPosition + 1].
	codeStream nextPutAll: '{ '.
	self indent: 1 while: [
		self indent.
		self formatStatementsFor: anArrayNode.
	].
	codeStream nextPutAll: '}'.
	anArrayNode stop ifNil: [anArrayNode rightBrace: self fullPosition].
! !

!RBFormatter methodsFor: 'visitor-double dispatching' stamp: 'ajh 3/13/2003 15:09'!
acceptAssignmentNode: anAssignmentNode 
	self indent: 2
		while: 
			[self visitNode: anAssignmentNode variable.
			codeStream space; nextPutAll: self class assignmentOperator; space.
			self visitNode: anAssignmentNode value]! !

!RBFormatter methodsFor: 'visitor-double dispatching' stamp: 'ajh 3/19/2003 15:50'!
acceptBlockNode: aBlockNode 
	| seqNode multiline formattedBody formatter start |
	seqNode := aBlockNode body.
	formatter := (self copy) lineStart: 0;
				yourself.
	start _ self fullPosition.
	formattedBody := formatter format: seqNode.
	multiline := self lineLength + formattedBody size > self maxLineSize
				or: [formatter isMultiLine].
	multiline ifTrue: [self indent].
	codeStream nextPut: $[.
	aBlockNode left ifNil: [aBlockNode left: self fullPosition].
	aBlockNode arguments do: 
			[:each | 
			codeStream nextPut: $:.
			self visitNode: each.
			codeStream nextPut: $ ].
	aBlockNode arguments isEmpty ifFalse: 
			[codeStream nextPutAll: '| '.
			multiline ifTrue: [self indent]].
	aBlockNode right ifNil: [
		"assume if block had no position seqNode had no position also"
		seqNode adjustPositionsAfter: start by: self fullPosition - start.
	].
	codeStream nextPutAll: formattedBody.
	codeStream nextPut: $].
	aBlockNode right ifNil: [aBlockNode right: self fullPosition].
! !

!RBFormatter methodsFor: 'visitor-double dispatching' stamp: 'ajh 7/3/2004 18:05'!
acceptLiteralNode: aLiteralNode

	| start s |
	start _ self fullPosition + 1.
	s _ codeStream position + 1.
	self formatLiteral: aLiteralNode value.
	aLiteralNode token start ifNil: [
		aLiteralNode token
			start: start;
			value: (codeStream originalContents copyFrom: s to: codeStream position)
	].
! !

!RBFormatter methodsFor: 'visitor-double dispatching' stamp: 'ajh 3/24/2003 13:15'!
acceptPseudoNode: aPseudoNode

	aPseudoNode isLabel ifTrue: [
		codeStream nextPut: $L.
		aPseudoNode destination printOn: codeStream.
		^ self].
	aPseudoNode isGoto ifTrue: [
		codeStream nextPut: $G.
		aPseudoNode destination printOn: codeStream.
		^ self].
	aPseudoNode isIf ifTrue: [
		codeStream nextPutAll: 'If '.
		codeStream nextPut: (aPseudoNode boolean ifTrue: [$t] ifFalse: [$f]).
		codeStream space.
		aPseudoNode destination printOn: codeStream.
		codeStream space.
		aPseudoNode otherwise printOn: codeStream.
		^ self].
! !

!RBFormatter methodsFor: 'visitor-double dispatching' stamp: 'ajh 3/19/2003 14:13'!
acceptReturnNode: aReturnNode

	aReturnNode start ifNil: [aReturnNode return: self fullPosition + 1].
	codeStream nextPut: $^; space.
	self visitNode: aReturnNode value! !

!RBFormatter methodsFor: 'visitor-double dispatching' stamp: 'ajh 3/19/2003 14:13'!
acceptVariableNode: aVariableNode

	aVariableNode token start ifNil: [
		aVariableNode token start: self fullPosition + 1].
	codeStream nextPutAll: aVariableNode name! !

!RBFormatter methodsFor: 'private-formatting' stamp: 'ajh 3/15/2003 01:22'!
formatLiteral: aValue 
	| isArray |
	(isArray := aValue class == Array) | (aValue class == ByteArray) ifTrue: 
			[codeStream nextPutAll: (isArray ifTrue: ['#('] ifFalse: ['#[']).
			self for: aValue
				do: [:each | self formatLiteral: each]
				separatedBy: [codeStream nextPut: $ ].
			codeStream nextPut: (isArray ifTrue: [$)] ifFalse: [$]]).
			^self].
	aValue isSymbol ifTrue: 
			[self formatSymbol: aValue.
			^self].
	aValue class == Character ifTrue: 
			[codeStream nextPut: $$;
				nextPut: aValue.
			^self].
	aValue isVariableBinding ifTrue: [
		codeStream nextPutAll: '##'; nextPutAll: aValue key.
		^ self].
	aValue storeOn: codeStream! !

!RBFormatter methodsFor: 'private-formatting' stamp: 'ajh 3/19/2003 16:03'!
formatMessage: aMessageNode cascade: cascadeBoolean 
	| selectorParts arguments multiLine formattedArgs indentFirst firstArgLength length start needsPos argStarts |
	selectorParts := aMessageNode selectorParts.
	needsPos _ selectorParts first start isNil.
	arguments := aMessageNode arguments.
	formattedArgs := OrderedCollection new.
	multiLine := aMessageNode selector numArgs > self maximumArgumentsPerLine.
	length := aMessageNode selector size + arguments size + 1.
	firstArgLength := 0.
	start _ self fullPosition.
	self indentWhile: 
			[1 to: arguments size
				do: 
					[:i | 
					| formatter string |
					formatter := (self copy) 
								lineStart: (selectorParts at: i) length negated;
								yourself.
					string := formatter format: (arguments at: i).
					formattedArgs add: string.
					i == 1 ifTrue: [firstArgLength := formatter firstLineLength].
					length := length + string size.
					multiLine := multiLine or: [formatter isMultiLine]]].
	multiLine := multiLine or: [length + self lineLength > self maxLineSize].
	indentFirst := cascadeBoolean not and: 
					[multiLine and: 
							[(self startMessageSendOnNewLine: aMessageNode) or: 
									[self lineLength + selectorParts first length + 2 + firstArgLength 
										> self maxLineSize]]].
	indentFirst ifTrue: [self indent].
	argStarts _ self 
		formatMessageSelector: selectorParts
		withArguments: formattedArgs
		multiline: multiLine.
	needsPos ifTrue: [
		arguments with: argStarts do: [:node :pos |
			node adjustPositionsAfter: start by: pos - start].
	].
! !

!RBFormatter methodsFor: 'private-formatting' stamp: 'ajh 3/19/2003 16:06'!
formatMessageSelector: selectorParts withArguments: formattedArgs multiline: multiLine

	| selectorPart argStarts |
	argStarts _ Array new: formattedArgs size.
	formattedArgs isEmpty 
		ifTrue: [
			selectorParts first start ifNil: [
				selectorParts first start: self fullPosition + 1].
			codeStream nextPutAll: selectorParts first value]
		ifFalse: 
			[1 to: formattedArgs size
				do: 
					[:i | 
					i ~~ 1 & multiLine not ifTrue: [codeStream nextPut: $ ].
					selectorPart _ selectorParts at: i.
					selectorPart start ifNil: [selectorPart start: self fullPosition + 1].
					codeStream 
						nextPutAll: selectorPart value;
						nextPut: $ .
					argStarts at: i put: self fullPosition.
					codeStream nextPutAll: (formattedArgs at: i).
					(multiLine and: [i < formattedArgs size]) ifTrue: [self indent]]].
	^ argStarts! !

!RBFormatter methodsFor: 'private-formatting' stamp: 'ajh 3/19/2003 14:15'!
formatMethodPatternFor: aMethodNode 
	| selectorParts arguments |
	selectorParts := aMethodNode selectorParts.
	arguments := aMethodNode arguments.
	arguments isEmpty
		ifTrue: [
			selectorParts first start ifNil: [selectorParts first start: self fullPosition + 1].
			codeStream nextPutAll: selectorParts first value]
		ifFalse: 
			[selectorParts with: arguments
				do: 
					[:selector :arg | 
					selector start ifNil: [selector start: self fullPosition + 1].
					codeStream nextPutAll: selector value;
						nextPut: $ .
					self visitArgument: arg.
					codeStream nextPut: $ ]]! !

!RBFormatter methodsFor: 'initialize-release' stamp: 'ajh 3/19/2003 14:03'!
initialize
	super initialize.
	codeStream := WriteStream on: (String new: 60).
	tabs := 0.
	lineStart := 0.
	positionDelta _ 0.
! !

!RBFormatter methodsFor: 'copying' stamp: 'ajh 3/19/2003 14:03'!
postCopy
	super postCopy.
	positionDelta _ positionDelta + codeStream position.
	lineStart := self lineLength negated.
	codeStream := WriteStream on: (String new: 60).
	firstLineLength := nil! !

!RBFormatter methodsFor: 'position fill' stamp: 'ajh 3/19/2003 14:12'!
fullPosition

	^ positionDelta + codeStream position! !


!RBFormatter class methodsFor: 'as yet unclassified' stamp: 'ajh 3/13/2003 18:55'!
assignmentOperator

	^ RBParser isSqueak
		ifTrue: ['_']
		ifFalse: [':=']! !


!RBPseudoNode methodsFor: 'visitor' stamp: 'ajh 3/17/2003 00:25'!
acceptVisitor: aProgramNodeVisitor
	^ aProgramNodeVisitor acceptPseudoNode: self! !

!RBPseudoNode methodsFor: 'testing' stamp: 'ajh 3/3/2003 18:41'!
isPseudo

	^ true! !

!RBPseudoNode methodsFor: 'accessing' stamp: 'ajh 3/20/2003 17:20'!
mapInstr

	^ mapInstr! !

!RBPseudoNode methodsFor: 'accessing' stamp: 'ajh 3/20/2003 17:19'!
mapInstr: irInstr

	mapInstr _ irInstr! !


!RBPseudoDupNode methodsFor: 'testing' stamp: 'ajh 3/2/2003 23:24'!
isDup

	^ true! !


!RBPseudoGotoNode methodsFor: 'testing' stamp: 'ajh 3/2/2003 23:23'!
isGoto

	^ true! !

!RBPseudoGotoNode methodsFor: 'testing' stamp: 'ajh 3/20/2003 19:05'!
isRet
	"is return"

	^ self destination = #return! !

!RBPseudoGotoNode methodsFor: 'as yet unclassified' stamp: 'ajh 3/3/2003 21:20'!
destination

	^ destination! !

!RBPseudoGotoNode methodsFor: 'as yet unclassified' stamp: 'ajh 3/9/2003 13:44'!
destination: seqNum

	destination _ seqNum! !

!RBPseudoGotoNode methodsFor: 'as yet unclassified' stamp: 'ajh 3/20/2003 01:16'!
forValue
	"true if sequence before me is for value, false if for effect"

	^ forValue and: [self isRet not]! !

!RBPseudoGotoNode methodsFor: 'as yet unclassified' stamp: 'ajh 3/4/2003 22:18'!
forValue: boolean
	"true if sequence before me is for value, false if for effect"

	forValue _ boolean! !


!RBPseudoIfNode methodsFor: 'testing' stamp: 'ajh 3/1/2003 20:13'!
isIf

	^ true! !

!RBPseudoIfNode methodsFor: 'as yet unclassified' stamp: 'ajh 3/3/2003 21:20'!
boolean

	^ boolean! !

!RBPseudoIfNode methodsFor: 'as yet unclassified' stamp: 'ajh 3/1/2003 23:08'!
boolean: bool

	boolean _ bool! !

!RBPseudoIfNode methodsFor: 'as yet unclassified' stamp: 'ajh 3/3/2003 21:20'!
destination

	^ destination! !

!RBPseudoIfNode methodsFor: 'as yet unclassified' stamp: 'ajh 3/9/2003 13:45'!
destination: seqNum

	destination _ seqNum! !

!RBPseudoIfNode methodsFor: 'as yet unclassified' stamp: 'ajh 3/3/2003 21:20'!
otherwise

	^ otherwise! !

!RBPseudoIfNode methodsFor: 'as yet unclassified' stamp: 'ajh 3/2/2003 23:19'!
otherwise: instructionSequence

	otherwise _ instructionSequence! !


!RBPseudoLabelNode methodsFor: 'testing' stamp: 'ajh 3/2/2003 23:23'!
isLabel

	^ true! !

!RBPseudoLabelNode methodsFor: 'as yet unclassified' stamp: 'ajh 3/3/2003 21:21'!
destination

	^ destination! !

!RBPseudoLabelNode methodsFor: 'as yet unclassified' stamp: 'ajh 3/9/2003 13:45'!
destination: seqNum

	destination _ seqNum! !


!RBPseudoPopNode methodsFor: 'testing' stamp: 'ajh 3/2/2003 23:23'!
isPop

	^ true! !


!RBPseudoSendNode methodsFor: 'as yet unclassified' stamp: 'ajh 3/23/2003 22:23'!
isPseudoSend

	^ true! !

!RBPseudoSendNode methodsFor: 'as yet unclassified' stamp: 'ajh 3/23/2003 22:23'!
selector

	^ selector! !

!RBPseudoSendNode methodsFor: 'as yet unclassified' stamp: 'ajh 3/23/2003 22:23'!
selector: aSelector

	selector _ aSelector! !


!RBReturnNode methodsFor: 'replacing' stamp: 'ajh 3/19/2003 16:16'!
adjustPositionsAfter: sourcePos by: delta
	"Slide token positions after sourcePos by delta"

	self return: return + delta.
	super adjustPositionsAfter: sourcePos by: delta.
! !

!RBReturnNode methodsFor: 'initialize-release' stamp: 'ajh 3/19/2003 13:51'!
return: returnInteger
	return := returnInteger! !

!RBReturnNode methodsFor: 'semantics' stamp: 'ajh 7/8/2004 20:57'!
binding

	^  self homeBinding! !

!RBReturnNode methodsFor: 'semantics' stamp: 'ajh 2/26/2003 14:48'!
homeBinding

	^  homeBinding! !

!RBReturnNode methodsFor: 'semantics' stamp: 'ajh 2/26/2003 14:40'!
homeBinding: aSemVar

	homeBinding _ aSemVar! !


!RBSequenceNode methodsFor: 'accessing' stamp: 'ajh 3/16/2003 18:24'!
stop

	^ ((periods isNil or: [periods isEmpty])
		ifTrue: [0]
		ifFalse: [periods last])
		max: (statements isEmpty
				ifTrue: [0]
				ifFalse: [statements last stop])! !


!RBVariableNode methodsFor: 'accessing' stamp: 'ajh 3/13/2003 15:17'!
token

	^ token! !

!RBVariableNode methodsFor: 'semantics' stamp: 'ajh 2/25/2003 00:50'!
binding

	^ binding! !

!RBVariableNode methodsFor: 'semantics' stamp: 'ajh 2/25/2003 23:41'!
binding: aSemVar

	binding _ aSemVar! !

!RBVariableNode methodsFor: 'replacing' stamp: 'ajh 3/13/2003 16:13'!
adjustPositionsAfter: sourcePos by: delta
	"Slide token positions after sourcePos by delta"

	token start > sourcePos ifTrue: [
		token start: token start + delta]! !

!RBVariableNode methodsFor: 'replacing' stamp: 'ajh 3/17/2003 13:12'!
changeToken: newToken

	self root adjustPositionsAfter: token stop by: newToken stop - token stop.
	token _ newToken.
! !


!Scanner class methodsFor: 'testing' stamp: 'ajh 3/24/2003 14:10'!
isLiteralSymbol: aSymbol 
	"Test whether a symbol can be stored as # followed by its characters.  
	Symbols created internally with asSymbol may not have this property, 
	e.g. '3' asSymbol."
	| i ascii type |
	i _ aSymbol size.
	i = 0 ifTrue: [^ false].
	ascii _ (aSymbol at: 1) asciiValue.
	"TypeTable should have been origined at 0 rather than 1 ..."
	ascii = 0 ifTrue: [^ false].
	type _ TypeTable at: ascii.
	(type == #xBinary or: [type == #verticalBar]) ifTrue: 
			[[i > 1]
				whileTrue: 
					[ascii _ (aSymbol at: i) asciiValue.
					ascii = 0 ifTrue: [^ false].
					type _ TypeTable at: ascii.
					(type == #xBinary or: [type == #verticalBar]) ifFalse: [^ false].
					i _ i - 1].
			^ true].
	type == #xLetter ifTrue: 
			[[i > 1]
				whileTrue: 
					[ascii _ (aSymbol at: i) asciiValue.
					ascii = 0 ifTrue: [^ false].
					type _ TypeTable at: ascii.
					(type == #xLetter or: [type == #xDigit or: [type == #xColon]])
						ifFalse: [^ false].
					i _ i - 1].
			^ true].
	^ false! !


!SmaCCScanner methodsFor: 'initialize-release' stamp: 'ajh 3/17/2003 12:05'!
on: aStream 
	stream := aStream.
	start := stream position + 1.! !

!SmaCCScanner methodsFor: 'private' stamp: 'ajh 3/17/2003 12:04'!
resetScanner
	start := stream position + 1.
	outputStream reset.
	lastOutputStreamMatchPosition := 0! !

!SmaCCScanner methodsFor: 'private' stamp: 'ajh 3/17/2003 12:05'!
scannerError
	(stream atEnd and: [start == (stream position + 1)]) 
		ifTrue: 
			[returnMatchBlock value: (SmaCCToken 
						value: ''
						start: start
						id: (Array with: self emptySymbolTokenId))].
	stream position: start - 1.
	returnMatchBlock value: (SmaCCToken 
				value: (String with: stream next)
				start: start
				id: #(0))! !


!SmaCCToken methodsFor: 'accessing' stamp: 'ajh 2/27/2003 17:55'!
length

	^ value size! !

!SmaCCToken methodsFor: 'accessing' stamp: 'ajh 3/11/2003 23:05'!
sourceInterval

	^ self start to: self stop! !

!SmaCCToken methodsFor: 'accessing' stamp: 'ajh 3/17/2003 12:03'!
start

	^ start! !

!SmaCCToken methodsFor: 'accessing' stamp: 'ajh 3/17/2003 12:03'!
startPosition
	^ start! !

!SmaCCToken methodsFor: 'accessing' stamp: 'ajh 3/17/2003 12:03'!
stop

	^ start ifNotNil: [start + value size - 1]! !

!SmaCCToken methodsFor: 'accessing' stamp: 'ajh 3/17/2003 12:03'!
stopPosition
	^ start + value size - 1! !

!SmaCCToken methodsFor: 'initialize-release' stamp: 'ajh 3/13/2003 14:04'!
start: startPositionInteger

	start _ startPositionInteger
! !

!SmaCCToken methodsFor: 'initialize-release' stamp: 'ajh 3/13/2003 15:25'!
value: anObject

	value _ anObject! !


!SmaCCToken class methodsFor: 'instance creation' stamp: 'ajh 3/13/2003 14:04'!
value: aString

	^ self value: aString start: nil id: nil! !

!SmaCCToken class methodsFor: 'instance creation' stamp: 'ajh 3/11/2003 23:28'!
value: aString start: anInteger

	^ self value: aString start: anInteger id: nil! !


!String methodsFor: 'private' stamp: 'ajh 3/18/2003 13:16'!
correctAgainstEnumerator: wordBlock continuedFrom: oldCollection
	"The guts of correction, instead of a wordList, there is a block that should take another block and enumerate over some list with it."

	| choices scoreMin results score maxChoices |
	scoreMin _ self size // 2 min: 3.
	maxChoices _ 10.
	oldCollection isNil
		ifTrue: [ choices _ SortedCollection sortBlock: [ :x :y | x value > y value ] ]
		ifFalse: [ choices _ oldCollection ].
	wordBlock isNil
		ifTrue:
			[ results _ OrderedCollection new.
			1 to: (maxChoices min: choices size) do: [ :i | results add: (choices at: i) key ] ]
		ifFalse:
			[ wordBlock value: [ :word |
				((score _ self alike: word) >= scoreMin
				 and: [(choices anySatisfy: [:assoc | assoc key = word]) not])
				ifTrue: [ choices add: (Association key: word value: score).
					     (choices size >= maxChoices) ifTrue: [ scoreMin _ (choices at: maxChoices) value] ] ].
			results _ choices ].
	^ results! !


!SystemDictionary methodsFor: 'housekeeping' stamp: 'ajh 3/15/2003 16:17'!
macroBenchmark1    "Smalltalk macroBenchmark1"
	"Decompiles and prettyPrints the source for every method in the system (or less depending on the *FILTER*, and then compiles that source and verifies that it generates (and decompiles to) identical code.  This currently fails in a number of places because some different patterns (esp involving conditionals where the first branch returns) decompile the same.  Because it never installs the new method, it should not cause any flusing of the method cache."
	 | methodNode oldMethod newMethod badOnes oldCodeString n classes |
	classes _ Smalltalk allClasses select: [:c | c name < 'B3'].
	badOnes _ OrderedCollection new.
'Decompiling and recompiling...'
displayProgressAt: Sensor cursorPoint
from: 0 to: (classes detectSum: [:c | c selectors size])
during: [:bar | n _ 0.
	classes do:
		[:cls | 
		"Transcript cr; show: cls name."
		cls selectors do:
			[:selector | bar value: (n _ n+1).
			oldMethod _ cls compiledMethodAt: selector.
			oldCodeString _ (oldMethod decompilerClass new
								decompile: selector in: cls method: oldMethod)
							decompileString.
			methodNode _ cls compilerClass new
						compile: oldCodeString
						in: cls notifying: nil ifFail: [].
			newMethod _ methodNode generate: #(0 0 0 0).
			oldCodeString = (newMethod decompilerClass new
								decompile: selector in: cls method: newMethod)
							decompileString ifFalse: [badOnes add: cls name , ' ' , selector]]].
].
	^ badOnes size! !

!SystemDictionary methodsFor: 'housekeeping' stamp: 'ajh 2/10/2003 14:37'!
recompileAll 
	"Recompile all classes"

	| n |
	Smalltalk forgetDoIts.
	n _ self classNames size.
	'Recompiling ', n printString, ' classes'
		displayProgressAt: Sensor cursorPoint from: 0 to: n
		during: [:bar |
			n _ 0.
			self allClassesDo: [:class |
				Transcript show: class name; cr.
				class compileAll.
				bar value: (n _ n + 1)]
		].

	"Smalltalk recompileAll"
! !

!SystemDictionary methodsFor: 'housekeeping' stamp: 'ajh 3/15/2003 16:17'!
testDecompiler    "Smalltalk testDecompiler"
	"Decompiles the source for every method in the system, and then compiles that source and verifies that it generates (and decompiles to) identical code.  This currently fails in a number of places because some different patterns (esp involving conditionals where the first branch returns) decompile the same."
	 | methodNode oldMethod newMethod badOnes oldCodeString n |
	badOnes _ OrderedCollection new.
	Smalltalk forgetDoIts.
'Decompiling all classes...'
displayProgressAt: Sensor cursorPoint
from: 0 to: CompiledMethod instanceCount
during: [:bar | n _ 0.
	Smalltalk allBehaviorsDo:
		[:cls | 
		"Transcript cr; show: cls name."
		cls selectors do:
			[:selector | (n _ n+1) \\ 100 = 0 ifTrue: [bar value: n].
			oldMethod _ cls compiledMethodAt: selector.
			oldCodeString _ (oldMethod decompilerClass new
								decompile: selector in: cls method: oldMethod)
							decompileString.
			methodNode _ cls compilerClass new
						compile: oldCodeString
						in: cls notifying: nil ifFail: [].
			newMethod _ methodNode generate: #(0 0 0 0).
			oldCodeString = (newMethod decompilerClass new
								decompile: selector in: cls method: newMethod)
							decompileString ifFalse: [Transcript cr; show: '***' , cls name , ' ' , selector.
											badOnes add: cls name , ' ' , selector]]].
].
	Smalltalk browseMessageList: badOnes asSortedCollection name: 'Decompiler Discrepancies'! !


!Text methodsFor: 'emphasis' stamp: 'ajh 7/6/2004 23:25'!
makeSelectorBold
	"For formatting Smalltalk source code, set the emphasis of that portion of 
	the receiver's string that parses as a message selector to be bold."

	| parser i |
	string size = 0 ifTrue: [^ self].
	i _ 0.
	[(string at: (i _ i + 1)) isSeparator] whileTrue.
	(string at: i) = $[ ifTrue: [^ self].  "block, no selector"
	[(parser _ Compiler parserClass new) parseSelector: string] on: Error do: [^ self].
	self makeBoldFrom: 1 to: (parser endOfLastToken min: string size)! !


!UndefinedObject methodsFor: 'class hierarchy' stamp: 'ajh 6/23/2004 20:40'!
parseScope

	^ GlobalScope new! !

!UndefinedObject methodsFor: 'class hierarchy' stamp: 'ajh 1/21/2003 13:03'!
parserClass

	^ Compiler parserClass! !

RBValueNode subclass: #RBVariableNode
	instanceVariableNames: 'token binding'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Parser'!
RBProgramNode subclass: #RBReturnNode
	instanceVariableNames: 'return value homeBinding'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Parser'!
RBProgramNodeVisitor subclass: #RBFormatter
	instanceVariableNames: 'codeStream lineStart firstLineLength tabs positionDelta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Parser'!
RBProgramNode subclass: #RBMethodNode
	instanceVariableNames: 'selector selectorParts body source arguments tags scope primitiveNode ir'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Parser'!
RBLiteralNode initialize!
RBValueNode subclass: #RBLiteralNode
	instanceVariableNames: 'token value'
	classVariableNames: 'Null'
	poolDictionaries: ''
	category: 'Refactory-Parser'!
RBValueNode subclass: #RBBlockNode
	instanceVariableNames: 'left right colons body arguments bar scope ir'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Parser'!
RBValueNode subclass: #RBArrayNode
	instanceVariableNames: 'leftBrace rightBrace statements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-SqueakRB-ParserExtensions'!
MethodContext removeSelector: #methodNode!
Message class removeSelector: #catcher!
Compiler initialize!
Compiler removeSelector: #cacheDoItNode:!
CompiledMethod removeSelector: #blockNode!
CompiledMethod removeSelector: #blockNodeIn:!
CompiledMethod removeSelector: #methodNode!
CompiledMethod removeSelector: #methodNodeDecompileClass:selector:!
IRBuilder removeSelector: #rargs:!
IRBuilder removeSelector: #thisContext:!
IRMethod removeSelector: #otherTempKeys:!
IRMethod removeSelector: #otherTempKeys!
IRMethod removeSelector: #rargKeys:!
IRMethod removeSelector: #rargKeys!
