Object subclass: #ClosureRuntimeStats
	instanceVariableNames: 'envCreationCount closureCreationCount closureCallCount milliseconds sendsPerSecond testName newObjectCount'
	classVariableNames: 'OldTests StartTime Tests'
	poolDictionaries: ''
	category: 'Compiler-Extras'!
!ClosureRuntimeStats commentStamp: 'ajh 5/21/2004 17:39' prior: 0!
Count the number of closure creations and calls while executing a given block.

 ClosureRuntimeStats on.
 ClosureRuntimeStats off inspect.

 (Closure measure: [...]) inspect.

 ClosureRuntimeStats testResults asArray.
 (ClosureRuntimeStats testResults allButFirst
	inject: ClosureRuntimeStats testResults first
	into: [:agg :stat | agg + stat])
	testName: 'Aggregate'
!


!ClosureRuntimeStats methodsFor: 'as yet unclassified' stamp: 'ajh 7/1/2004 15:33'!
+ stat

	| agg |
	(stat isKindOf: self class) ifFalse: [self error: 'can''t add stats'].

	agg _ self class basicNew.
	#(envCreationCount closureCreationCount closureCallCount milliseconds) do: [:var |
		agg instVarNamed: var put:
			(self instVarNamed: var) + (stat instVarNamed: var)].
	^ agg! !

!ClosureRuntimeStats methodsFor: 'as yet unclassified' stamp: 'ajh 5/21/2004 15:00'!
closureCallsPerSecond

	^ ((closureCallCount first: 6) / (milliseconds / 1000)) truncated! !

!ClosureRuntimeStats methodsFor: 'as yet unclassified' stamp: 'ajh 7/1/2004 15:35'!
closureCreationPerSecond

	^ (closureCreationCount / (milliseconds / 1000)) truncated! !

!ClosureRuntimeStats methodsFor: 'as yet unclassified' stamp: 'ajh 7/1/2004 15:33'!
copyResults

	milliseconds _ Time millisecondClockValue - StartTime.
	envCreationCount _ EnvCreationCount.
	closureCreationCount _ ClosureCreationCount.
	closureCallCount _ ClosureCallCount.

	newObjectCount _ NewObjectCount.
! !

!ClosureRuntimeStats methodsFor: 'as yet unclassified' stamp: 'ajh 7/1/2004 15:34'!
envCreationPerSecond

	^ ((envCreationCount first: 6) / (milliseconds / 1000)) truncated! !

!ClosureRuntimeStats methodsFor: 'as yet unclassified' stamp: 'ajh 5/21/2004 16:09'!
newObjectsPerSecond

	^ (newObjectCount / (milliseconds / 1000)) truncated! !

!ClosureRuntimeStats methodsFor: 'as yet unclassified' stamp: 'ajh 5/21/2004 13:54'!
sendsPerSecond

	^ sendsPerSecond ifNil: [sendsPerSecond _ 0 tinyBenchmarks]! !

!ClosureRuntimeStats methodsFor: 'as yet unclassified' stamp: 'ajh 5/21/2004 14:03'!
sendsPerSecond: string

	sendsPerSecond _ string! !


!ClosureRuntimeStats methodsFor: 'printing' stamp: 'ajh 7/1/2004 18:03'!
longPrintOn: stream

	stream print: testName; cr; cr.

	stream nextPutAll: 'New objects per sec: '.
	stream print: self newObjectsPerSecond; cr; cr.

	stream nextPutAll: 'New envs per sec: '.
	stream print: self envCreationPerSecond sum; cr.
	stream nextPutAll: 'by num free vars: '.
	stream print: self envCreationPerSecond; cr; cr.

	stream nextPutAll: 'New closures per sec: '.
	stream print: self closureCreationPerSecond; cr; cr.

	stream nextPutAll: 'Closure calls per sec: '.
	stream print: self closureCallsPerSecond sum; cr.
	stream nextPutAll: 'by num free vars: '.
	stream print: self closureCallsPerSecond; cr; cr.

	stream nextPutAll: self sendsPerSecond; cr.
! !

!ClosureRuntimeStats methodsFor: 'printing' stamp: 'ajh 5/21/2004 13:45'!
printOn: stream

	stream print: self class; space.
	stream print: testName.
! !

!ClosureRuntimeStats methodsFor: 'printing' stamp: 'ajh 5/21/2004 13:58'!
testName
	"Just for documentation to distinguish multiple instances"

	^ testName! !

!ClosureRuntimeStats methodsFor: 'printing' stamp: 'ajh 5/21/2004 11:45'!
testName: name
	"Just to document for when you have multiple instances"

	testName _ name! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ClosureRuntimeStats class
	instanceVariableNames: ''!

!ClosureRuntimeStats class methodsFor: 'run' stamp: 'ajh 5/21/2004 00:05'!
measure: block

	self on.
	block value.
	^ self off
! !

!ClosureRuntimeStats class methodsFor: 'run' stamp: 'ajh 5/21/2004 16:07'!
off

	| stats |
	stats _ self new copyResults.
	self installOriginalObjectMethods.
	stats sendsPerSecond: 0 tinyBenchmarks.
	^ stats! !

!ClosureRuntimeStats class methodsFor: 'run' stamp: 'ajh 5/21/2004 16:06'!
on

	self installCountObjectMethods.
! !


!ClosureRuntimeStats class methodsFor: 'initialize' stamp: 'ajh 7/1/2004 15:28'!
initCounters

	Smalltalk at: #ClosureCreationCount put: 0.
	
	"indexed by number of free vars"
	Smalltalk at: #EnvCreationCount put: (Array new: 100 withAll: 0).
	Smalltalk at: #ClosureCallCount put: (Array new: 100 withAll: 0).
	
	Smalltalk at: #NewObjectCount put: 0.

	StartTime _ Time millisecondClockValue.
! !

!ClosureRuntimeStats class methodsFor: 'initialize' stamp: 'ajh 5/21/2004 13:43'!
initialize

	Tests _ OrderedCollection new.
	self initCounters.
! !

!ClosureRuntimeStats class methodsFor: 'initialize' stamp: 'ajh 5/21/2004 16:06'!
installCountObjectMethods

	{{Behavior. #primBasicNew. #primBasicNew}.
	 {Behavior. #primBasicNew:. #primBasicNew:}.
	 {Behavior. #basicNew. #traceBasicNew}.
	 {Behavior. #basicNew:. #traceBasicNew:}
	} do: [:triple |
		triple first
			addSelectorSilently: triple second
			withMethod: (self class compiledMethodAt: triple third)].

	self installTracingMethods.
! !

!ClosureRuntimeStats class methodsFor: 'initialize' stamp: 'ajh 7/1/2004 15:20'!
installOriginalMethods

	{{BlockClosure. #valueWithArguments:. #primValueWithArguments:}.
	} do: [:triple |
		triple first
			addSelectorSilently: triple second
			withMethod: (self class compiledMethodAt: triple third)].

	{{ClosureEnvironment class. #new:}.
	 {BlockClosure class. #new}.
	 {BlockClosure. #primValueWithArguments:}.
	} do: [:pair |
		pair first removeSelectorSimply: pair second].
! !

!ClosureRuntimeStats class methodsFor: 'initialize' stamp: 'ajh 5/21/2004 16:06'!
installOriginalObjectMethods

	{{Behavior. #basicNew. #primBasicNew}.
	 {Behavior. #basicNew:. #primBasicNew:}
	} do: [:triple |
		triple first
			addSelectorSilently: triple second
			withMethod: (self class compiledMethodAt: triple third)].

	{{Behavior. #primBasicNew}.
	 {Behavior. #primBasicNew:}
	} do: [:pair |
		pair first removeSelectorSimply: pair second].

	self installOriginalMethods.
! !

!ClosureRuntimeStats class methodsFor: 'initialize' stamp: 'ajh 7/1/2004 15:06'!
installTracingMethods

	{{BlockClosure class. #new. #blockClosureNew}.
	 {BlockClosure. #primValueWithArguments:. #primValueWithArguments:}.
	 {BlockClosure. #valueWithArguments:. #valueWithArguments:}.
	 {ClosureEnvironment class. #new:. #envNew:}.
	} do: [:triple |
		triple first
			addSelectorSilently: triple second
			withMethod: (self class compiledMethodAt: triple third)].

	self initCounters.
! !


!ClosureRuntimeStats class methodsFor: 'tracing methods' stamp: 'ajh 7/1/2004 17:32'!
blockClosureNew

	ClosureCreationCount _ ClosureCreationCount + 1.

	^ self basicNew! !

!ClosureRuntimeStats class methodsFor: 'tracing methods' stamp: 'ajh 7/1/2004 17:32'!
envNew: size

	| array n |
	array _ EnvCreationCount.
	n _ size + 1.
	array at: n put: (array at: n) + 1.

	^ self basicNew: size! !

!ClosureRuntimeStats class methodsFor: 'tracing methods' stamp: 'ajh 5/21/2004 15:49'!
traceBasicNew

	NewObjectCount _ NewObjectCount + 1.

	^ self primBasicNew! !

!ClosureRuntimeStats class methodsFor: 'tracing methods' stamp: 'ajh 5/21/2004 15:49'!
traceBasicNew: size

	NewObjectCount _ NewObjectCount + 1.

	^ self primBasicNew: size! !

!ClosureRuntimeStats class methodsFor: 'tracing methods' stamp: 'ajh 7/1/2004 18:00'!
valueWithArguments: args

	| n array e |
	e _ self env.
	n _ e class == ClosureEnvironment
		ifTrue: [e size]
		ifFalse: [1].
	n _ n + 1.
	(array _ ClosureCallCount) at: n put: (array at: n) + 1.

	^ self primValueWithArguments: args! !


!ClosureRuntimeStats class methodsFor: 'original methods' stamp: 'ajh 5/21/2004 15:48'!
primBasicNew
	"Primitive. Answer an instance of the receiver (which is a class) with no 
	indexable variables. Fail if the class is indexable. Essential. See Object 
	documentation whatIsAPrimitive."

	<primitive: 70>
	self isVariable ifTrue: [ ^ self basicNew: 0 ].
	"space must be low"
	self environment signalLowSpace.
	^ self basicNew  "retry if user proceeds"
! !

!ClosureRuntimeStats class methodsFor: 'original methods' stamp: 'ajh 5/21/2004 15:49'!
primBasicNew: sizeRequested 
	"Primitive. Answer an instance of this class with the number
	of indexable variables specified by the argument, sizeRequested.
	Fail if this class is not indexable or if the argument is not a
	positive Integer, or if there is not enough memory available. 
	Essential. See Object documentation whatIsAPrimitive."

	<primitive: 71>
	self isVariable ifFalse:
		[self error: self printString, ' cannot have variable sized instances'].
	(sizeRequested isInteger and: [sizeRequested >= 0]) ifTrue:
		["arg okay; space must be low."
		self environment signalLowSpace.
		^ self basicNew: sizeRequested  "retry if user proceeds"].
	self primitiveFailed! !

!ClosureRuntimeStats class methodsFor: 'original methods' stamp: 'ajh 7/1/2004 17:19'!
primValueWithArguments: anArray 
	"Primitive. Evaluate the block represented by the receiver. The argument 
	is an Array whose elements are the arguments for the block. Fail if the 
	length of the Array is not the same as the the number of arguments that 
	the block was expecting. Fail if the block is already being executed. 
	Essential. See Object documentation whatIsAPrimitive."

	"<primitive: 187>"
	^ self env withArgs: anArray executeMethod: self method! !


!ClosureRuntimeStats class methodsFor: 'tests' stamp: 'ajh 5/21/2004 13:57'!
testResults
	"Collection of previously run test results"

	^ Tests! !


Object subclass: #ClosureStaticStats
	instanceVariableNames: 'methodsByEmbeddedBlocks blocksByFreeVars homeFunctionsByEscapingEnvs problemMethods'
	classVariableNames: 'LastStats'
	poolDictionaries: ''
	category: 'Compiler-Extras'!
!ClosureStaticStats commentStamp: 'ajh 5/21/2004 14:52' prior: 0!
After recompiling the image under the new closure compiler (using Recompiler), use this to find distribution of:
number of closures per method,
number of free vars per closure.
number of indirect free vars per closure.
number of indirect temp vars per method with closure(s).
number of indirect temp vars per method.

 ClosureStaticStats new run inspect.

 ClosureStaticStats lastStats.
!


!ClosureStaticStats methodsFor: 'as yet unclassified' stamp: 'ajh 5/20/2004 02:18'!
allMethodsDo: methodBlock

	| count |
	count _ 0.
	Smalltalk allClassesDo: [:class | count _ count +
		({class. class class} collect: [:behavior |
			behavior methodDictionary size]) sum].
	
	'Checking ', count printString, ' methods'
		displayProgressAt: Sensor cursorPoint from: 0 to: count
		during: [:bar | | m | m _ 0.
			Smalltalk allClassesDo: [:class |
				{class. class class} do: [:behavior |
					behavior methodDictionary do: [:meth |
						methodBlock value: meth.
						bar value: (m _ m + 1)]]]].
! !

!ClosureStaticStats methodsFor: 'as yet unclassified' stamp: 'ajh 7/1/2004 10:47'!
initBags

	methodsByEmbeddedBlocks _ Bag new.
	blocksByFreeVars _ Bag new.
	homeFunctionsByEscapingEnvs _ Bag new.

	problemMethods _ OrderedCollection new.
! !

!ClosureStaticStats methodsFor: 'as yet unclassified' stamp: 'ajh 7/1/2004 10:47'!
longPrintOn: stream

	| list |
	list _ [:bag | (0 to: 9) collect: [:i | bag valuesAndCounts at: i ifAbsent: [0]]].

	stream nextPutAll: 'Methods: '.
	stream print: methodsByEmbeddedBlocks size; cr.
	stream nextPutAll: 'by num closures: '.
	stream print: (list value: methodsByEmbeddedBlocks); cr; cr.

	stream nextPutAll: 'Home methods/blocks: '.
	stream print: homeFunctionsByEscapingEnvs size; cr.
	stream nextPutAll: 'by having own env: '.
	stream print: (list value: homeFunctionsByEscapingEnvs); cr; cr.

	stream nextPutAll: 'Closures: '.
	stream print: blocksByFreeVars size; cr.
	stream nextPutAll: 'by num free vars: '.
	stream print: (list value: blocksByFreeVars); cr.
! !

!ClosureStaticStats methodsFor: 'as yet unclassified' stamp: 'ajh 7/8/2004 19:19'!
run
	"scan all methods collecting stats"

	self initBags.
	self allMethodsDo: [:meth |
		| blockMeths |
		blockMeths _ meth allEmbeddedBlockMethods.
		methodsByEmbeddedBlocks add: blockMeths size.
		blockMeths size > 0 ifTrue: [
			homeFunctionsByEscapingEnvs add: meth ast scope hasEscapingEnv asBit].
		[blockMeths do: [:bm | | ast |
			ast _ bm ast.
			bm containsBlockClosures ifTrue: [
				homeFunctionsByEscapingEnvs add: ast scope hasEscapingEnv asBit].
			blocksByFreeVars add: ast freeVars size.
		]] on: Error do: [problemMethods add: meth].
	].
	LastStats _ self.
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ClosureStaticStats class
	instanceVariableNames: ''!

!ClosureStaticStats class methodsFor: 'as yet unclassified' stamp: 'ajh 5/20/2004 02:20'!
lastStats

	^ LastStats! !


Object subclass: #Recompiler
	instanceVariableNames: 'problemMethods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Compiler-Extras'!
!Recompiler commentStamp: 'ajh 7/8/2004 21:18' prior: 0!
[Recompiler new inspect; recompileImage] forkAt: 30
!


!Recompiler methodsFor: 'recompile' stamp: 'ajh 7/8/2004 20:42'!
recompile: selector in: class
	"Recompile method in class. If method can't be recompiled (because of compile error) add it to problemMethods with general reason"

	| source oldMethod trailer methodNode newMethod |
	oldMethod _ class compiledMethodAt: selector.
	"oldMethod isClosureCompiled ifTrue: [^ self]."
	source _ class sourceCodeAt: selector.
	source ifNil: [^ self problem: 'no source' sel: selector in: class].
	trailer _ oldMethod trailer.
	methodNode _ Compiler new
		compile: source in: class notifying: self
		ifFail: [^ self problem: 'syntax error' sel: selector in: class].
	selector == methodNode selector ifFalse: [
		^ self problem: 'selector changed' sel: selector in: class].
	newMethod _ methodNode generate: trailer.
	class addSelectorSilently: selector withMethod: newMethod.
! !

!Recompiler methodsFor: 'recompile' stamp: 'ajh 5/19/2004 23:29'!
recompileClass: class

	{class. class class} do: [:behavior |
		behavior selectorsDo: [:selector |
			[self recompile: selector in: behavior]
				on: Error
				do: [:ex | self problem: ex description sel: selector in: behavior]]]
! !

!Recompiler methodsFor: 'recompile' stamp: 'ajh 5/19/2004 23:28'!
recompileImage
	"Recomiles all class/instance methods in image. Methods that can't be recompiled (because of compile error) are added to problemMethods and are not recompiled"

	"ProtoObject allSubclasses includes metaclasses"
	| m |
	m _ 0.
	Smalltalk allClassesDo: [:class | m _ m + 1].
	'Recompiling ', m printString, ' classes'
		displayProgressAt: Sensor cursorPoint from: 0 to: m
		during: [:bar | | n |
			n _ 0.
			Smalltalk allClassesDo: [:class |
				self recompileClass: class.
				bar value: (n _ n + 1)].
			self recompileClass: ProtoObject.
		].
! !


!Recompiler methodsFor: 'requestor interface' stamp: 'ajh 5/19/2004 17:32'!
interactive
	"Batch compiling, not interactive"

	^ false! !

!Recompiler methodsFor: 'requestor interface' stamp: 'ajh 5/19/2004 17:32'!
notify: aString at: anInteger in: aStream
	"Called from Parser2 on syntax error. Do nothing and let fail block handle it"
! !


!Recompiler methodsFor: 'problem methods' stamp: 'ajh 5/19/2004 18:16'!
initialize

	problemMethods _ OrderedCollection new.
! !

!Recompiler methodsFor: 'problem methods' stamp: 'ajh 5/19/2004 18:16'!
problem: reason sel: selector in: class

	problemMethods add: {class. selector. reason}! !

ClosureRuntimeStats initialize!